/*
   Written by Pieter J. Schoenmakers <tiggr@ics.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: os.c,v 1.1 1998/04/08 10:57:36 tiggr Exp $  */

#include <dlfcn.h>

void
dload_initialize ()
{
}

void *
dload_load (char *name)
{
  return dlopen (name, RTLD_NOW);
}

void *
dload_lookup (void *handle, char *name)
{
  return dlsym (handle, name);
}
