
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse otm_parse
#define yylex otm_lex
#define yyerror otm_error
#define yylval otm_lval
#define yychar otm_char
#define yydebug otm_debug
#define yynerrs otm_nerrs
#define	CLASS	258
#define	END	259
#define	EXTENSION	260
#define	EXTERN	261
#define	IMPLEMENTATION	262
#define	INSTANCE	263
#define	INTERFACE	264
#define	POSING	265
#define	RECEIVER	266
#define	SUPER	267
#define	CONST	268
#define	LOCAL	269
#define	OLD	270
#define	IF	271
#define	ELSE	272
#define	DO	273
#define	FOR	274
#define	WHILE	275
#define	BREAK	276
#define	CONTINUE	277
#define	RETURN	278
#define	PRE	279
#define	POST	280
#define	PUBLIC	281
#define	PRIVATE	282
#define	PROTECTED	283
#define	MUTABLE	284
#define	STATIC	285
#define	DEFERRED	286
#define	REDEFINE	287
#define	REDECLARE	288
#define	CATCH	289
#define	BIND	290
#define	UNWIND	291
#define	DYNAMIC	292
#define	EQ	293
#define	GE	294
#define	LE	295
#define	NE	296
#define	AND	297
#define	OR	298
#define	IMPLIES	299
#define	SHL	300
#define	SHR	301
#define	LSR	302
#define	TYPEDEF	303
#define	VOID	304
#define	NIL	305
#define	PLUSPLUS	306
#define	MINMIN	307
#define	ASSIGN	308
#define	STRING_CST	309
#define	IDENTIFIER	310
#define	NUMBER	311
#define	TYPE	312
#define	BASIC_TYPE	313
#define	C_LITERAL	314
#define	UNARY_MINUS	315

#line 12 "parse.y"

#import <tl/tl.h>
#import <time.h>
#import "global.h"
#import "OTMAlias.h"
#import "OTMAliasAlias.h"
#import "OTMArgument.h"
#import "OTMAssignment.h"
#import "OTMBasic.h"
#import "OTMBind.h"
#import "OTMBreak.h"
#import "OTMBuiltinMethod.h"
#import "OTMCast.h"
#import "OTMCatch.h"
#import "OTMCondExpr.h"
#import "OTMConstant.h"
#import "OTMContinue.h"
#import "OTMClass.h"
#import "OTMCompound.h"
#import "OTMCustomMethod.h"
#import "OTMDynamicType.h"
#import "OTMError.h"
#import "OTMExpr.h"
#import "OTMExtension.h"
#import "OTMIdentifier.h"
#import "OTMInstance.h"
#import "OTMInvocation.h"
#import "OTMITE.h"
#import "OTMLocalVar.h"
#import "OTMLoop.h"
#import "OTMMetaRef.h"
#import "OTMModAssign.h"
#import "OTMNumberCST.h"
#import "OTMObjectVar.h"
#import "OTMOld.h"
#import "OTMReturn.h"
#import "OTMStringCST.h"
#import "OTMTuple.h"
#import "OTMTypeTuple.h"
#import "OTMUnvocation.h"
#import "OTMUnwind.h"
#import "OTMVariable.h"
#import "OTMVarRef.h"

/* Forward declarations.  */
extern int otm_lex ();
void do_postponed_aliases (BOOL must);

#define YYDEBUG 1
#define YYERROR_VERBOSE

int current_line;
id <TLString> current_filename;

/* The current unit.  */
LTTUnit *current_unit;

/* The current output file.  It is NIL when parsing a file which is not to
   be output.  */
id <TLOutputStream> of;

/* The extensions output to the output file.  */
TLSet *extensions_output;

/* The current class or the current instance.
   Only one of these will ever be !NIL.  */
LTTClass *current_class;
LTTInstance *current_instance;

/* This is either the CURRENT_CLASS or the CURRENT_INSTANCE, whichever is
   !nil (they can't be both).  */
LTTMeta *current_either;

/* The current extension.  The main definition of a class or instance is
   also an extension.  It is called the main extension.  */
LTTExtension *current_extension;

/* In a definition, or during the pre and post conditions of a
   declaration, the current method.  */
OTMCustomMethod *current_method;

/* The meta involved in the meta or method or whatever currently being
   output to the output file, be it as a declaration, or as a definition.  */
LTTMeta *output_current_context;

/* Similarly, the method.  */
OTMCustomMethod *output_current_method;

/* The current compound.  */
OTMCompound *current_compound;

/* The type enclosing the current local variable declaration.  */
OTMType *enclosing_type;

/* Semantics to some of the above.  */
#define C_EXT_SEMANTICS		(OTMExtension *) [current_extension semantics]
#define C_CLS_SEMANTICS		(OTMClass *) [current_class semantics]
#define C_INS_SEMANTICS		(OTMInstance *) [current_instance semantics]
#define C_EITHER_SEMANTICS	(OTMMeta *) [current_either semantics]

static enum
{
  GLOBAL_SCOPE,
  INTERFACE_SCOPE,
  IMPLEMENTATION_SCOPE,
} in_what;

/* Lists of still-to-patch supers.  Each entry is a cons cell holding the
   LTTMeta and the super meta.  Semantics of the inheritance depends on
   the list.  The STATE_SUPERS holds instances, but inheritance applies to
   both the instance and its class.  The BEHAVIOUR_SUPERS only applies to
   the actual metas involved.  */
TLCons *postponed_state_supers, *postponed_behaviour_supers;

TLCons *postponed_aliases;

/* The index number of the next argument.  */
int next_arg;

void
yyerror (char *s)
{
  extern char *yytext;
  error (@"parse error at `%s' (%s)", yytext, s);
}

LTTInstance *
instance_in_unit (id <TLString> unit_name, LTTUnit *current,
		  TLVector *instances)
{
  LTTInstance *i = ltt_instance_in_unit (unit_name, current, instances);

  if (!i && instances)
    error (@"ambiguous reference to %@",
	   [[(LTTInstance *) [instances _elementAtIndex: 0] lttName]
	    internal]);

  if (of && (postponed_state_supers || postponed_behaviour_supers))
    do_postponed_supers (1);

  return i;
}

/* Return a a pair of a variable with the name N and the type T, and the
   DEF expression, or, if T is a type-tuple and N is a tuple of names, and
   they correspond, return a pair of a properly typed tuple of properly
   typed variables, and the default value.

   Thus, this return CONS (arg, value).  */
id
digest_arguments (id n, id t, id def)
{
  BOOL ntup = ![n stringp];
  BOOL ttup = [t isTuple];
  OTMExpr *ret;

  /* A tuple with one element is not a real tuple.  */
  if (ttup)
    {
      TLVector *tv = [t elements];
      if ([tv length] == 1)
	{
	  t = [tv _elementAtIndex: 0];

	  /* XXX What is a tuple consisting of only a tuple?  What if the
             contained tuple also contains only a single element?  */
	  ttup = [t isTuple];
	}
    }

  /* If T is a tuple, it is a Real Tuple (> 1 element).  */
  if (ttup)
    {
      if (!ntup)
	{
	  error (@"attempt to declare `%@' with tuple type", n);
	  return nil;
	}
      else
	{
	  TLVector *tv = [(id) t elements], *nv = [n elements];
	  int i, nn = [nv length], tn = [tv length];
	  TLVector *vars;

	  if (tn != nn)
	    {
	      error (@"number of elements (%d) does not match type (%d)",
		     nn, tn);
	      return nil;
	    }

	  /* Create a vector of typed variables, by zipping the name tuple
             and type tuple.  */
	  vars = [CO_TLVector vectorWithCapacity: tn];
	  for (i = 0; i < nn; i++)
	    [vars addElement: [CO_OTMArgument variableWithName:
					      [nv _elementAtIndex: i]
					      type: [tv _elementAtIndex: i]
					      number: next_arg++]];

	  ret = [CO_OTMTuple tupleWithSequence: vars];
	  [ret setType: t];
	}
    }
  else if (ntup > 1)
    {
      error (@"non-tuple type for tupled argument");
      return nil;
    }
  else
    {
      if (ntup == 1)
	n = [[n elements] _elementAtIndex: 0];
      ret = [CO_OTMArgument variableWithName: n type: t number: next_arg++];
    }

  return CONS (ret, def);
}

/* Load the FILE.  Iff !INTERFACE, the implementation will be loaded.
   Otherwise, the interface will be preferred.  Iff META_NAME, the meta
   with that name must be declared after having read the file.  Iff MUST,
   the file type indicated by the INTERFACE must be found; otherwise an
   error is issued.  */
void
load_file (LTTFile *file, id <TLString> meta_name, BOOL interface, BOOL must)
{
  TLString *full_name = nil;
  FILE *f;
  GCDECL1;

  GCPRO1 (full_name);

  /* Open the file, preferring `.j' above `.t', unless !INTERFACE.  */
  if (!interface)
    f = NULL;
  else
    {
      if ([file loadedInterface] || (!must && [file loadedImplementation]))
	return;

      full_name = [file interfaceFilename];
      f = fopen ([full_name cString], "r");
      if (f)
	[file setLoadedInterface];
      else if (must)
	{
	  error (@"%@: %s", full_name, ERRMSG);
	  return;
	}
      else if (ERRNO != ENOENT)
	warning (@"%@: %s", full_name, ERRMSG);
    }

  if (!f)
    {
      if ([file loadedImplementation] || (!must && [file loadedInterface]))
	return;

      full_name = [file implementationFilename];
      f = fopen ([full_name cString], "r");
      if (f)
	[file setLoadedImplementation];
      else
	error (@"%@: %s", full_name, ERRMSG);
    }

  if (f)
    {
      char buf[4096];
      const char *s;
      TLVector *v;
      int mi, mn;

      s = [full_name cString];
      if (s[0] != '/')
	{
	  /* Make the path absolute.  */
	  if (getcwd (buf, sizeof (buf)))
	    full_name = [CO_TLString stringWithFormat: @"%s/%s", buf, s];
	}

      parse_file (full_name, [file unit], f);
      fclose (f);

      for (mi = 0, v = [file items], mn = [v length]; mi < mn; mi++)
	{
	  LTTExtension *ext = [v _elementAtIndex: mi];
	  OTMExtension *sem = [ext semantics];

	  if (!sem || !([sem definedp] || [sem declaredp]))
	    error (@"%@ fails to define or declare %@",
		   full_name, ltt_ext_name (ext));
	}
    }

  GCUNPRO;
}

/* Load the interface (or the implementation) of the extension EXT.  */
void
load_extension_interface (LTTExtension *ext)
{
  LTTFile *file = [ext container];
  id pof = nil;
  GCDECL1;

  GCPRO1 (pof);

  pof = of;
  of = nil;

  /* Only check the meta in case we're loading the main extension.  */
  load_file (file, [ext isMainExtension] ? [[ext meta] lttName] : nil, 1, 0);

  of = pof;

  GCUNPRO;
}

/* Load the meta M.  This implies that all files which have defined
   extensions or posing classes for M are loaded.  */
void
load_interface (LTTInstance *ins)
{
  LTTExtension *ext;

  /* If the main extension's file has been set loaded, we do not do
     anything since that file will declare this meta.  */
  if (![[ins semantics] fullyLoaded])
    {
      int previous_in_what = in_what;
      TLVector *exts = 0;
      int i, n;
      GCDECL1;

      GCPRO1 (exts);

      [[ins semantics] setFullyLoaded];

      exts = [ins extensions];
      for (i = 0, n = [exts length]; i < n; i++)
	{
	  ext = [exts _elementAtIndex: i];
	  if (![[ext container] loadedInterface]
	      && ![[ext container] loadedImplementation])
	    load_extension_interface (ext);
	}

      GCUNPRO;

      in_what = previous_in_what;
    }

  {
    LTTMeta *p = [ins posedSelf];

    if ((id) ins != p)
      load_interface ([p classp] ? (id) [p instance] : p);
  }
}

/* Add the method declaration of METHOD to the current extension.  */
void
add_method_decl (OTMCustomMethod *method)
{
  BOOL ok = YES, shown = NO;
  OTMMethod *orig;

  if (!current_extension)
    return;

  if (in_what == IMPLEMENTATION_SCOPE && [C_EXT_SEMANTICS declaredp]
      && ![method foreign] && ![method deferredp])
    error (@"method declaration in implementation scope");

  orig = [C_EITHER_SEMANTICS searchSimilarMethod: method];
  if (orig)
    {
      otm_qualifiers q = [method qualifiers];
      otm_qualifiers oq = [orig qualifiers];

      if (![method foreign] && !Q_DEFERRED (oq))
	{
	  if ([method extension] == [orig extension])
	    {
	      error (@"duplicate declaration of identical method");
	      if (!shown)
		cerror_for (orig, @"previous declaration was here");
	      ok = NO;
	    }

	  // XXX This is a hack.  The `searchSimilarMethod:' should return
	  // a list of applicable methods (i.e. all of those in scope,
	  // which can be multiple methods for multiple extensions of this
	  // either)
	  if (([[[orig extension] structure] meta]
	       == [[[method extension] structure] meta])
	      && [[[method extension] structure] isMainExtension])
	    ;
	  else if (!Q_REDO (q))
	    {
	      if (!flag_inhibit_unqualified_redeclare)
		{
		  warning (@"unqualified redeclaration of undeferred method");
		  if (!shown)
		    cerror_for (orig, @"previous declaration was here");
		}
	      [method setRedo: OQ_REDEFINE];
	    }
	}
      if (!Q_PROTECTION (q))
	Q_SET_PROTECTION (q, Q_PROTECTION (oq));
      else if (Q_PROTECTION (q) != Q_PROTECTION (oq))
	{
	  error (@"protection %@ differs from original declaration",
		 qualifier_name (Q_PROTECTION (q)));
	  error_for (orig, @"original protection %@ declared here",
		     qualifier_name (Q_PROTECTION (oq)));
	  [method setProtection: Q_PROTECTION (oq)];
	}

      /* XXX `Inherit' the default arguments from the original?  */
    }

  if (ok)
    {
      /* Make sure the selector of this method is registered.
	 This is needed for foreign methods.  */
      if (of)
	[method selector];

      /* No need to add the declaration of a foreign method twice.  */
      if (in_what == IMPLEMENTATION_SCOPE && [method foreign]
	  && [method extension] == [orig extension])
	return;
      else
	{
	  [C_EXT_SEMANTICS addMethod: method];
	  [method setDeclared: YES];
	}
    }
}

/* Add the method declaration or definition of METHOD with the PRE and
   POST conditions to the current extension.  */
OTMCustomMethod *
add_method_def (OTMCustomMethod *method)
{
  OTMMethod *orig;
  OTMExtension *ext;
  BOOL ok = YES, shown = NO;

  if (!current_extension)
    return nil;

  ext = [method extension];
  orig = [C_EXT_SEMANTICS searchSimilarMethod: method];

  if (orig)
    {
      if (ext == [orig extension])
	{
	  if ([orig definedp])
	    {
	      error (@"redefinition of prototypicially identical method");
	      if (!shown)
		{
		  cerror_for (orig, @"previous definition was here");
		  shown = YES;
		}
	      ok = NO;
	    }
	}
    }
  else
    {
      /* In an implementation, if the interface has been seen, this method
         must have been declared.  */
      if (in_what == IMPLEMENTATION_SCOPE && [ext declaredp])
	error (@"definition of undeclared method %@", method_name (method, 0));
    }

  if (ok && orig
      && ![orig allowedRedeclaration: method
		inSubclass: ([[ext structure] meta]
			     != [[[orig extension] structure] meta])])
    {
      error (@"argument type mismatch with declaration");
      if (!shown)
	{
	  cerror_for (orig, @"previous definition was here");
	  shown = YES;
	}
      ok = NO;
    }

  if (ok)
    {
      if (orig)
	{
	  id f;

	  [method warnDifferingArguments: orig];
	  method = (id) orig;

	  [method refreshLocation];

	  f = [method foreign];
	  if (f)
	    [(OTMCustomMethod *) orig setForeign: f];
	}
      else
	{
	  TLVector *v;

	  v = [C_EXT_SEMANTICS methodsNamed: [method methodName] create: YES];
	  [v addElement: method];
	}

      [method setDefined: YES];

      /* Make sure the selector of this method is registered.
	 This is needed for foreign methods.  */
      if (of && !NUM_ERRORS)
	[method selector];
    }

  return method;
}

/* Add CI to the behavioural super information of SUBI.  */
void
add_super_1 (LTTMeta *subi, LTTMeta *ci)
{
  OTMMeta *cis = [ci semantics];

  if (![cis declaredp] && ![cis definedp])
    postponed_behaviour_supers = CONS (CONS (subi, ci),
				       postponed_behaviour_supers);
  else if ([ci isDirectSub: subi]
	   && (in_what == INTERFACE_SCOPE
	       || (in_what == IMPLEMENTATION_SCOPE
		   && ![[subi semantics] declaredp])))
    warning (@"%@: repeated immediate super %@",
	     ltt_meta_name (subi), ltt_meta_name (ci));
  else
    {
      [subi addBehaviourSuper: ci];
      [[[subi extensionNamed: [[current_extension lttName] internal]] semantics]
	addSuper: cis];
    }
}

/* Handle the normal case of straight inheritance (without shifting meta
   levels).  */
static void
add_super_0 (LTTInstance *subi, LTTInstance *ci)
{
  BOOL already = [ci isDirectSub: subi];
  LTTClass *subc = [subi itsClass];
  LTTClass *cc = [ci itsClass];
  OTMMeta *subis = [subi semantics];
  OTMMeta *cis = [ci semantics];

  if (![cis declaredp] && ![cis definedp])
    postponed_state_supers = CONS (CONS (subi, ci), postponed_state_supers);
  else if (already
	   && (in_what == INTERFACE_SCOPE
	       || (in_what == IMPLEMENTATION_SCOPE && ![subis declaredp])))
    warning (@"%@: repeated immediate super %@",
	     ltt_meta_name (subi), ltt_meta_name (ci));
  else if (!already && in_what == IMPLEMENTATION_SCOPE && [subis declaredp])
    error_for ([subi semantics],
	       @"%@: super indication was absent in interface",
	       ltt_meta_name (ci));
  else
    {
      LTTName *cename = current_extension ? [current_extension lttName] : nil;
      id <TLString> cenamei = cename ? [cename internal] : nil;

      [subi addStateSuper: ci];
      [subc addStateSuper: cc];
      [[[subi extensionNamed: cenamei] semantics] addSuper: cis];
      [[[subc extensionNamed: cenamei] semantics] addSuper: [cc semantics]];
      if ([cis statep])
	[[subi semantics] setStatep];
      if ([[cc semantics] statep])
	[[subc semantics] setStatep];
    }
}

/* Add C to be a super of the current meta.  If !direction, this is state
   inheritance (even if C has no state).  If it is -1, it is inheritance
   of the instance behaviour only.  If it is +1, it indicates inheritance
   of the class behaviour only.  */
static void
add_super (LTTInstance *inst, int direction)
{
  if (!direction)
    {
      if (current_instance)
	add_super_0 (current_instance, inst);
      else if (current_class)
	add_super_0 ([current_class instance], inst);
    }
  else if (direction < 0)
    add_super_1 (current_either, inst);
  else
    add_super_1 (current_either, [inst itsClass]);
}

static void
do_add_super (id what, int posing)
{
  int dir = 0;

  if ([what consp])
    {
      id a, d;

      DECONS (what, a, d);
      if (a)
	what = a, dir = 1;
      else
	what = d, dir = -1;
    }

  add_super (what, dir);

  if (posing)
    {
      /* XXX Check consistency.  */

    }
}

void
do_postponed_aliases (BOOL must)
{
  TLCons *list = postponed_aliases;

  postponed_aliases = nil;

  while (list)
    {
      OTMAliasAlias *a;

      DECONS (list, a, list);
      [[a extension] handlePostponedAlias: a];
    }

  if (must && postponed_aliases)
    internal (@"non-empty postponed aliases");
}

void
do_postponed_supers (BOOL must)
{
  TLCons *states = postponed_state_supers;
  TLCons *behaviours = postponed_behaviour_supers;
  int previous_in_what = in_what;
  id sub, sup;
  TLCons *c;

  postponed_behaviour_supers = postponed_state_supers = nil;
  in_what = GLOBAL_SCOPE;

  while (states)
    {
      DECONS (states, c, states);
      DECONS (c, sub, sup);
      add_super_0 (sub, sup);
    }

  while (behaviours)
    {
      DECONS (behaviours, c, behaviours);
      DECONS (c, sub, sup);
      add_super_1 (sub, sup);
    }

  if (must && (postponed_state_supers || postponed_behaviour_supers))
    internal (@"non-empty postponed supers");

  in_what = previous_in_what;
}

/* Add the variables from the VARS list to the current_either with the
   indicated qualifiers and TYPE.  */
void
object_add_variables (otm_qualifiers q, id type, TLCons *vars, BOOL is_local)
{
  id <TLString> name;
  OTMObjectVar *var;
  
  q = mask_qualifiers (q, ((current_instance ? 0 : OQ_STATIC_MASK)
			   | OQ_PROTECTION_MASK | OQ_MUTABLE_MASK
			   | OQ_REDO_MASK));

  if (Q_REDO (q) && Q_REDO (q) != OQ_REDECLARE)
    q = mask_qualifiers (q, 0);

  if (Q_REDO (q) && is_local)
    {
      error (@"can't redeclare something as local");
      is_local = 0;
    }

  if (!current_either)
    return;

  if (in_what == IMPLEMENTATION_SCOPE && [[current_either semantics] declaredp])
    while (vars)
      {
	OTMCustomMethod *m;
	OTMExpr *e;

	DECONS (vars, name, vars);

	/* XXX Check consistency with declaration.  */
	var = [C_EXT_SEMANTICS variableNamed: name];

	if (!var)
	  {
	    error (@"declaration of %@ not found in interface", name);
	    continue;
	  }

	if ([var type] != type)
	  {
	    error (@"differing declaration of %@", name);
	    error_for (var, @"previous declaration was here");
	  }

	/* Generate the accessor methods.  */
	if (Q_PROTECTION (q) == OQ_PUBLIC)
	  {
	    m = add_method_def ((id) [CO_OTMCustomMethod
				      methodWithExtension: C_EXT_SEMANTICS
				      name: accessor_method_name (name)
				      returnType: type flatp: NO]);
	    current_method = m;
	    current_compound = [CO_OTMCompound compoundWithContainer: (id) m];
	    [current_method setBody: current_compound];
	    e = [CO_OTMAssignment assignmentWithLhs:
			       temp_something_with_type ([var type], 0)
			       rhs: var];
	    e = emit_expr (e);
	    [m setReturnValue: e];
	    current_compound = nil;
	    if (of && !NUM_ERRORS)
	      [current_method compile];
	    current_method = nil;
	  }

	if (Q_MUTABLE (q))
	  {
	    m = add_method_def
	      ((id) [CO_OTMCustomMethod methodWithExtension: C_EXT_SEMANTICS
		     nameTypes: CONS (CONS (modifier_method_name (name),
					    CONS ([CO_OTMVariable
						   variableWithName:
						   @"value" type: type], nil)),
				      nil)
		     returnType: basic_type[BT_VOID] flatp: NO]);

	    current_method = m;
	    current_compound = [CO_OTMCompound compoundWithContainer: (id) m];
	    [current_method setBody: current_compound];
	    e = [CO_OTMAssignment assignmentWithLhs:
		 [C_EITHER_SEMANTICS searchEntityNamed: name supers: YES
		  class: YES variables: YES constants: YES]
		 rhs: [current_compound searchVariableNamed: @"value"]];
	    e = emit_expr (e);
	    current_compound = nil;
	    if (of && !NUM_ERRORS)
	      [current_method compile];
	    current_method = nil;
	  }
      }
  else
    while (vars)
      {
	OTMMethod *m;

	DECONS (vars, name, vars);

	if (Q_REDO (q))
	  var = [C_EXT_SEMANTICS aliasWithName: name
				 type: type qualifiers: q];
	else
	  {
	    if (current_either != ltt_instance_state
		&& current_either != ltt_class_state)
	      {
		var = [C_EITHER_SEMANTICS searchEntityNamed: name
					  supers: YES class: YES
					  variables: YES constants: YES];
		if (var)
		  {
		    warning (@"declaration of %@ hides previous declaration",
			     name);
		    cwarning_for (var, @"%@ previously declared here", name);
		  }
	      }

	    var = [C_EXT_SEMANTICS variableWithName: name
				   type: type qualifiers: q];
	    if (is_local)
	      if (![var staticp] || ![current_either classp])
		error_for (var,
			   @"non-static or non-class variable can't be local");
	      else
		{
		  [var setIsThreadLocal];
		  [C_EITHER_SEMANTICS setThreadLocalVarsP];
		}
	  }

	if (Q_PROTECTION (q) == OQ_PUBLIC)
	  {
	    m = [CO_OTMCustomMethod methodWithExtension: C_EXT_SEMANTICS
				    name: accessor_method_name (name)
				    returnType: type flatp: NO];
	    if (Q_REDO (q) == OQ_REDECLARE)
	      [m setRedo: OQ_REDECLARE];
	    add_method_decl ((id) m);
	  }
	if (Q_MUTABLE (q))
	  {
	    m = [CO_OTMCustomMethod methodWithExtension: C_EXT_SEMANTICS
		     nameTypes: CONS (CONS (modifier_method_name (name),
				  CONS ([CO_OTMVariable variableWithName:
					      @"value" type: type], nil)), nil)
				    returnType: basic_type[BT_VOID] flatp: NO];
	    if (Q_REDO (q) == OQ_REDECLARE)
	      [m setRedo: OQ_REDECLARE];

	    add_method_decl ((id) m);
	  }
      }
}

/* Add the variables from the VARS list to the current_either with the
   indicated qualifiers and TYPE.  */
void
object_add_const (otm_qualifiers q, id <TLString> name, id value)
{
  OTMConstant *c;
  
  q = mask_qualifiers (q, OQ_PROTECTION_MASK);

  if (!current_either)
    return;

  c = [C_EXT_SEMANTICS constantWithName: name qualifiers: q value: value];
}

/* Check the super class declarations of the current meta.  */
static void
check_supers (void)
{
  if ([current_extension isMainExtension])
    {
      /* Make sure Any and State are supers.  */
      if (current_class)
	{
	  /* XXX Should search in the other direction...  */
	  if (current_class != ltt_class_state
	      && ![ltt_class_state isProperStateSub: current_class])
	    [current_class addStateSuper: ltt_class_state];
	  if (![ltt_class_any isProperSub: current_class])
	    [current_class addBehaviourSuper: ltt_class_any];

	  /* Make both the class and instance of this EITHER a superclass
             of All.  */
	  [ltt_instance_all addBehaviourSuper: current_class];
	  [ltt_instance_all addBehaviourSuper: [current_class instance]];
	}
      else if (current_instance
	       && ![ltt_instance_any isProperSub: current_instance])
	[current_instance addBehaviourSuper: ltt_instance_any];
    }
}

/* Setup everything for the interface or implementation (depends on
   DEFINITIONP) of instance or class (depending on IS_CLASS) of the
   extension EXT of the INSTANCE.  If !EXT this is the main extension.  */
static void
set_current_either (LTTInstance *instance, id <TLString> ext, int is_class,
		    id <TLString> foreign, otm_qualifiers q, int definitionp)
{
  OTMMeta *either, *counterpart;
  id <TLString> errmsg;

  current_class = nil;
  current_instance = nil;
  current_either = nil;
  current_extension = nil;

  if (!instance)
    return;

  /* We're loading a named extension.  Make sure the main extension is
     also loaded.  */
  if (ext && ![[[instance extensionNamed: nil] container] loadedInterface])
    load_interface (instance);

  q = mask_qualifiers (q, 0);

  if (is_class)
    current_either = current_class = [instance itsClass];
  else
    current_either = current_instance = instance;

  errmsg = ltt_meta_name (current_either);
  either = C_EITHER_SEMANTICS;
  counterpart = [(is_class ? (LTTMeta *) [(LTTClass *) current_either instance]
		  : (LTTMeta *) [current_either itsClass]) semantics];

  if (ext)
    {
      if (!([either declaredp] || [either definedp]
	    || [[[current_either extensionNamed: nil]
		 container] loadedInterface]))
	internal (@"interface of `%@' not found", errmsg);

      if (current_either == ltt_instance_any || current_either == ltt_class_any
	  || current_either == ltt_instance_all
	  || current_either == ltt_class_all)
	error (@"extensions of %@ not allowed", ltt_meta_name (current_either));
    }
  else
    {
      if (definitionp)
	{
	  if ([either definedp] && ![either foreign])
	    {
	      error (@"redefinition of %@", errmsg);
	      cerror_for (either, @"previous definition of %@ was here",
			  errmsg);
	    }

	  if (Q_DEFERRED (q) && [either declaredp] && ![either deferredp])
	    {
	      error (@"deferred status mismatch with interface of %@", errmsg);
	      cerror_for (either, @"previous declaration was here");
	    }
	}
      else
	{
	  if ([either declaredp])
	    error (@"redeclaration of %@", errmsg);
	  else
	    [either refreshLocation];
	}

      if (!is_class)
	{
	  /* Foreign is only allowed on a class interface.  Instance
	     interface and any implementation are not allowed.  */
	  if (foreign || [[[current_instance itsClass] semantics] foreign])
	    error (@"foreign instances are not possible");

	  /* The declaration of the class must have been seen before the
	     instance is encountered.  */
	  if (![counterpart declaredp] && ![counterpart definedp])
	    error (@"declaration of %@ should preceed %@ of %@",
		   ltt_meta_name ([counterpart structure]),
		   definitionp ? @"definition" : @"declaration",
		   ltt_meta_name (current_instance));
	}
      else
	{
	  if (foreign && ![either declaredp])
	    if (definitionp)
	      error (@"implementation of foreign class meaningless");
	    else
	      {
		[either setForeign: foreign];
		[counterpart setDeclared: YES];
	      }
	}

      if (definitionp)
	[either setDefined: YES];
      else
	[either setDeclared: YES];

      if (Q_DEFERRED (q))
	{
	  /* XXX This kind of information which is applicable to both the
	     instance and the class, should reside in the class; not in
	     both.  */
	  [either setDeferred: YES];
	  [counterpart setDeferred: YES];
	}
    }

  current_extension = [current_either extensionNamed: ext];
  if (!current_extension)
    {
      current_extension = [CO_LTTExtension extensionWithName: ext
					file: ltt_missing_file
					meta: current_either];

      error (@"inventing %@", ltt_ext_name (current_extension));
    }

  if (definitionp)
    {
      [C_EXT_SEMANTICS setDefined: YES];

      if (of)
	{
	  [extensions_output addElement: C_EXT_SEMANTICS];
	  if ([current_extension isMainExtension])
	    if (current_class)
	      {
		[C_EXT_SEMANTICS addSuper: [ltt_class_any semantics]];
		[C_EXT_SEMANTICS addSuper: [ltt_class_state semantics]];
	      }
	    else if (current_instance)
	      [C_EXT_SEMANTICS addSuper: [ltt_instance_any semantics]];
	}
    }
  else
    {
      [C_EXT_SEMANTICS setDeclared: YES];

      if (foreign)
	{
	  /* This is a class.  Set the instance declared.  */
	  [[[[counterpart structure] extensionNamed: ext]
	    semantics] setDeclared: YES];

	  /* Make sure the information on the class object in this
             interface is output.  */
	  if (of)
	    [extensions_output addElement: C_EXT_SEMANTICS];
	}
    }

  if (current_extension)
    push_report_context (formac (nil, @"in %@",
				 ltt_ext_name (current_extension)));
  else if (current_either)
    push_report_context (formac (nil, @"in %@",
				 ltt_meta_name (current_either)));
  else
    push_report_context (formac (nil, @"somewhere in `%@'", current_filename));

  in_what = definitionp ? IMPLEMENTATION_SCOPE : INTERFACE_SCOPE;
}

OTMExpr *
do_return_stmt (int kind, OTMExpr *expr)
{
  OTMExpr *r = nil;

  if (current_method)
    if (expr)
      {
	id rt = [current_method returnType];

	if (rt == basic_type[BT_VOID])
	  if (kind)
	    r = [CO_OTMReturn assignmentWithLhs: void_expr rhs: expr];
	  else
	    {
	      warning (@"setting void return value has no effect");
	      r = expr;
	    }
	else
	  {
	    OTMExpr *e = [current_method returnValue];

	    if (expr == void_expr)
	      {
		if (!e)
		  {
		    e = temp_something_with_type (rt, 0);
		    emit_assignment (e, nil_something_with_type (rt));
		    [current_method setReturnValue: e];
		  }

		/* Allow `return;' to indicate immediate return without
		   affecting the return value.  */
		expr = e;
	      }
	    else if (!e)
	      {
		e = temp_something_with_type (rt, 0);
		[current_method setReturnValue: e];
	      }

	    r = (kind == 1 ? [CO_OTMReturn assignmentWithLhs: e rhs: expr]
		 : (id) [CO_OTMAssignment assignmentWithLhs: e rhs: expr]);
	  }

	if (kind == 1)
	  [current_method setHaveReturnStatement];
      }

  return r;
}

OTMCompound *
enter_compound (void)
{
  if (current_compound || current_method)
    {
      current_compound = [CO_OTMCompound compoundWithContainer:
					 (current_compound ? current_compound
					  : (id) current_method)];
      if (![current_method body])
	[current_method setBody: current_compound];
    }

  return current_compound;
}

void
exit_compound (void)
{
  if (current_compound)
    {
      current_compound = [current_compound container];
      if (current_compound == (id) current_method)
	current_compound = nil;
    }
}

void
init_local_var (OTMVariable *v, OTMType *t, OTMExpr *expr)
{
  if (current_compound)
    {
      emit_local_var (v);
      emit_assignment (v, [resolve_expr (expr ? expr
					 : nil_something_with_type (t),
					 CONS (t, nil), nil,
					 C_EITHER_SEMANTICS) elaborate]);
      [current_compound releaseTemporaryVariables];
    }
}

OTMLocalVar *
create_local_var (id <TLString> name, OTMType *type, OTMExpr *expr)
{
  OTMLocalVar *r = [CO_OTMLocalVar variableWithName: name type: type];

  init_local_var (r, type, expr);

  return r;
}

#line 1173 "parse.y"
typedef union {
  int i;
  id v;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		469
#define	YYFLAG		-32768
#define	YYNTBASE	85

#define YYTRANSLATE(x) ((unsigned)(x) <= 315 ? yytranslate[x] : 205)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    77,     2,     2,     2,    75,    70,     2,    81,
    82,    73,    71,    61,    72,    84,    74,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    65,    60,    66,
    63,    67,    64,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    79,     2,    83,    68,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    62,    69,    80,    76,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    78
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     7,    10,    13,    16,    18,    19,    20,
    33,    34,    35,    36,    50,    51,    52,    65,    66,    67,
    68,    82,    83,    84,    89,    90,    94,    98,   103,   109,
   111,   113,   115,   117,   119,   121,   123,   125,   127,   129,
   131,   136,   141,   145,   147,   151,   152,   155,   157,   160,
   164,   169,   171,   176,   181,   182,   184,   187,   188,   191,
   194,   197,   200,   201,   205,   206,   207,   215,   216,   218,
   219,   222,   225,   228,   231,   234,   237,   240,   243,   247,
   251,   252,   255,   256,   259,   260,   262,   264,   267,   271,
   277,   279,   282,   284,   286,   288,   290,   292,   294,   296,
   298,   300,   302,   304,   306,   308,   310,   312,   314,   316,
   318,   320,   322,   324,   326,   328,   330,   332,   334,   336,
   338,   340,   342,   344,   346,   348,   350,   352,   354,   356,
   358,   360,   362,   364,   368,   369,   371,   374,   378,   380,
   381,   384,   385,   390,   391,   396,   397,   399,   401,   404,
   406,   409,   411,   413,   414,   419,   421,   423,   424,   428,
   430,   434,   436,   440,   441,   442,   443,   451,   452,   455,
   456,   463,   464,   465,   471,   472,   473,   485,   488,   490,
   492,   494,   498,   501,   504,   507,   510,   514,   518,   523,
   528,   529,   531,   532,   533,   536,   538,   540,   542,   544,
   547,   549,   551,   553,   555,   557,   559,   561,   563,   564,
   569,   570,   571,   577,   581,   585,   587,   591,   593,   596,
   598,   601,   603,   605,   608,   611,   614,   617,   621,   625,
   629,   633,   637,   641,   645,   649,   653,   657,   661,   665,
   669,   673,   677,   681,   685,   689,   693,   697,   703,   708,
   710,   712,   714,   716,   718,   720,   722,   724,   726,   731,
   736,   741,   743,   745,   750,   755,   760,   768,   771,   775,
   777,   779,   781,   784,   787,   791,   795,   797,   798,   802,
   805,   807,   811,   813,   815,   817,   819,   821,   823,   825,
   827,   829,   833,   837,   839,   841,   845,   847
};

static const short yyrhs[] = {    -1,
    85,    86,     0,    87,   197,     0,    94,   197,     0,    90,
   197,     0,    97,   197,     0,    59,     0,     0,     0,     9,
   124,   125,     3,   200,   115,    88,   112,    89,   101,   117,
     4,     0,     0,     0,     0,     7,   124,   125,     3,   200,
   115,    91,   112,    92,   101,    93,   136,     4,     0,     0,
     0,     9,   124,   125,     8,   200,   115,    95,   112,    96,
   101,   117,     4,     0,     0,     0,     0,     7,   124,   125,
     8,   200,   115,    98,   112,    99,   101,   100,   136,     4,
     0,     0,     0,    62,   102,   103,    80,     0,     0,   103,
   104,   197,     0,   125,   105,   196,     0,    14,   125,   105,
   196,     0,   125,    13,    55,    63,   175,     0,    58,     0,
   110,     0,   109,     0,    49,     0,    37,     0,   105,     0,
    37,     0,   105,     0,   105,     0,   201,     0,    11,     0,
     3,    81,   109,    82,     0,     8,    81,   109,    82,     0,
    81,   111,    82,     0,   108,     0,   111,    61,   108,     0,
     0,    65,   113,     0,   114,     0,    10,   114,     0,   113,
    61,   114,     0,   113,    61,    10,   114,     0,   203,     0,
     8,    81,   203,    82,     0,     3,    81,   203,    82,     0,
     0,   116,     0,     5,   204,     0,     0,   117,   118,     0,
   117,   137,     0,   117,     1,     0,   121,   197,     0,     0,
   121,   120,   138,     0,     0,     0,   122,   125,   124,   126,
   123,   127,   128,     0,     0,     6,     0,     0,   125,    30,
     0,   125,    31,     0,   125,    29,     0,   125,    32,     0,
   125,    33,     0,   125,    26,     0,   125,    28,     0,   125,
    27,     0,   106,   129,   133,     0,   106,   129,   130,     0,
     0,    24,   185,     0,     0,    25,   185,     0,     0,   135,
     0,   131,     0,   130,   131,     0,   132,   107,   134,     0,
   132,   107,   134,    63,   175,     0,   133,     0,   133,    65,
     0,    65,     0,    55,     0,    35,     0,     3,     0,    34,
     0,     4,     0,     5,     0,     6,     0,     7,     0,     8,
     0,     9,     0,    14,     0,    10,     0,    11,     0,    12,
     0,    13,     0,    16,     0,    17,     0,    18,     0,    19,
     0,    20,     0,    21,     0,    22,     0,    23,     0,    26,
     0,    27,     0,    28,     0,    29,     0,    30,     0,    31,
     0,    32,     0,    33,     0,    37,     0,    48,     0,    36,
     0,    49,     0,    50,     0,    58,     0,    57,     0,    55,
     0,   135,     0,    81,   196,    82,     0,     0,   137,     0,
   136,   119,     0,    48,   105,    55,     0,   197,     0,     0,
   139,   140,     0,     0,    62,   141,   144,    80,     0,     0,
    62,   143,   144,    80,     0,     0,   145,     0,   146,     0,
   145,   146,     0,   147,     0,   150,   197,     0,    59,     0,
   148,     0,     0,   149,    62,   144,    80,     0,   174,     0,
   197,     0,     0,   105,   151,   152,     0,   153,     0,   152,
    61,   153,     0,    55,     0,    55,    63,   175,     0,     0,
     0,     0,    16,   155,   194,   156,   148,   157,   158,     0,
     0,    17,   148,     0,     0,    18,   160,   146,    20,   194,
   197,     0,     0,     0,    20,   162,   194,   163,   146,     0,
     0,     0,    19,    81,   172,   197,   165,   171,   197,   166,
   172,    82,   146,     0,   168,   175,     0,   168,     0,    63,
     0,    23,     0,   186,    63,   175,     0,    51,   186,     0,
   186,    51,     0,    52,   186,     0,   186,    52,     0,   186,
    53,   175,     0,   170,    63,   175,     0,   175,    79,   195,
    83,     0,   175,    79,     1,    83,     0,     0,   175,     0,
     0,     0,   173,   176,     0,   154,     0,   164,     0,   159,
     0,   161,     0,   175,   197,     0,   185,     0,   169,     0,
   167,     0,   184,     0,   183,     0,   177,     0,   175,     0,
   142,     0,     0,    34,   181,   178,   175,     0,     0,     0,
    35,   179,   181,   180,   175,     0,    36,   181,   175,     0,
    81,   182,    82,     0,   176,     0,   182,    60,   176,     0,
    21,     0,    21,   175,     0,    22,     0,    22,   175,     0,
   186,     0,   170,     0,    72,   175,     0,    76,   175,     0,
    77,   175,     0,    15,   175,     0,   175,    73,   175,     0,
   175,    74,   175,     0,   175,    75,   175,     0,   175,    71,
   175,     0,   175,    72,   175,     0,   175,    45,   175,     0,
   175,    46,   175,     0,   175,    47,   175,     0,   175,    70,
   175,     0,   175,    69,   175,     0,   175,    68,   175,     0,
   175,    66,   175,     0,   175,    40,   175,     0,   175,    38,
   175,     0,   175,    41,   175,     0,   175,    39,   175,     0,
   175,    67,   175,     0,   175,    42,   175,     0,   175,    43,
   175,     0,   175,    44,   175,     0,   175,    64,   175,    65,
   175,     0,   175,    64,   175,     1,     0,    56,     0,   187,
     0,    55,     0,    49,     0,    50,     0,   194,     0,   190,
     0,   188,     0,    54,     0,   189,    81,   175,    82,     0,
   189,    81,    12,    82,     0,   189,    81,     1,    82,     0,
   109,     0,    58,     0,    79,   176,   191,   199,     0,    79,
   201,   191,   199,     0,    79,    12,   191,   199,     0,    79,
    12,    81,   109,   198,   191,   199,     0,    55,   194,     0,
    79,     1,    83,     0,   132,     0,   192,     0,   193,     0,
   192,   193,     0,   132,   175,     0,    81,   195,    82,     0,
    81,     1,    82,     0,   176,     0,     0,   195,    61,   176,
     0,   195,    61,     0,    55,     0,   196,    61,    55,     0,
    60,     0,     1,     0,    82,     0,     1,     0,    83,     0,
     1,     0,   202,     0,   202,     0,    57,     0,    57,    84,
    57,     0,    55,    84,    57,     0,   201,     0,    55,     0,
    55,    84,    55,     0,    55,     0,    57,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
  1238,  1240,  1243,  1245,  1246,  1247,  1248,  1255,  1262,  1266,
  1273,  1280,  1284,  1288,  1298,  1305,  1309,  1316,  1323,  1327,
  1331,  1341,  1343,  1347,  1350,  1352,  1355,  1361,  1366,  1379,
  1381,  1382,  1385,  1387,  1388,  1391,  1393,  1396,  1403,  1408,
  1412,  1416,  1422,  1432,  1437,  1443,  1445,  1448,  1453,  1457,
  1461,  1467,  1469,  1473,  1479,  1481,  1484,  1488,  1490,  1491,
  1492,  1498,  1506,  1514,  1522,  1527,  1560,  1566,  1568,  1574,
  1576,  1587,  1593,  1599,  1605,  1611,  1617,  1623,  1631,  1638,
  1647,  1649,  1656,  1658,  1665,  1667,  1670,  1672,  1678,  1684,
  1691,  1693,  1698,  1704,  1706,  1707,  1708,  1709,  1710,  1711,
  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
  1742,  1749,  1751,  1754,  1761,  1763,  1764,  1767,  1774,  1791,
  1808,  1810,  1832,  1842,  1847,  1854,  1859,  1862,  1864,  1867,
  1878,  1898,  1902,  1908,  1912,  1917,  1918,  1926,  1932,  1937,
  1939,  1945,  1950,  1956,  1962,  1966,  1970,  1976,  1981,  1987,
  1993,  2003,  2010,  2014,  2021,  2029,  2033,  2053,  2058,  2064,
  2066,  2069,  2074,  2080,  2086,  2092,  2098,  2103,  2113,  2120,
  2127,  2132,  2135,  2140,  2145,  2154,  2156,  2157,  2158,  2159,
  2162,  2164,  2165,  2166,  2167,  2168,  2171,  2173,  2176,  2192,
  2197,  2213,  2219,  2227,  2248,  2255,  2260,  2266,  2271,  2277,
  2282,  2288,  2290,  2298,  2302,  2306,  2310,  2314,  2318,  2322,
  2326,  2330,  2334,  2338,  2342,  2346,  2350,  2354,  2358,  2362,
  2366,  2370,  2374,  2378,  2382,  2386,  2390,  2394,  2398,  2404,
  2406,  2407,  2443,  2447,  2451,  2452,  2453,  2456,  2467,  2483,
  2488,  2495,  2497,  2500,  2505,  2510,  2515,  2521,  2527,  2534,
  2536,  2539,  2541,  2547,  2554,  2564,  2571,  2577,  2582,  2587,
  2594,  2599,  2605,  2607,  2613,  2615,  2621,  2623,  2629,  2633,
  2644,  2649,  2655,  2661,  2663,  2669,  2685,  2687
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"END","EXTENSION","EXTERN","IMPLEMENTATION","INSTANCE","INTERFACE","POSING",
"RECEIVER","SUPER","CONST","LOCAL","OLD","IF","ELSE","DO","FOR","WHILE","BREAK",
"CONTINUE","RETURN","PRE","POST","PUBLIC","PRIVATE","PROTECTED","MUTABLE","STATIC",
"DEFERRED","REDEFINE","REDECLARE","CATCH","BIND","UNWIND","DYNAMIC","EQ","GE",
"LE","NE","AND","OR","IMPLIES","SHL","SHR","LSR","TYPEDEF","VOID","NIL","PLUSPLUS",
"MINMIN","ASSIGN","STRING_CST","IDENTIFIER","NUMBER","TYPE","BASIC_TYPE","C_LITERAL",
"';'","','","'{'","'='","'?'","':'","'<'","'>'","'^'","'|'","'&'","'+'","'-'",
"'*'","'/'","'%'","'~'","'!'","UNARY_MINUS","'['","'}'","'('","')'","']'","'.'",
"file","file_element","class_interface","@1","@2","class_implementation","@3",
"@4","@5","instance_interface","@6","@7","instance_implementation","@8","@9",
"@10",".object_variables.","@11","object_variables","object_variable","entity_type",
"return_type","argument_type","tuple_elt_type","object_type","tuple_type","tuple_type_field_list",
".colon_super_list.","super_list","super_indication",".extension.","extension",
"decl_list","annotated_method_decl","method_def","@12","shared_method_part",
"@13","@14",".foreign.",".qualifiers.","method_decl",".pre.",".post.",".return_value_name.",
"method_decl_parts","method_decl_part","method_name_part","bare_method_name_part",
"argument_name","tuple_argument_name","def_list","typedef","method_body","@15",
"method_body_expression","@16","compound","@17","top_expression_list","ne_top_expression_list",
"top_expression","actual_top_expression","top_expr","@18","local_var","@19",
"local_var_decl_list","local_var_decl","if_stmt","@20","@21","@22",".if_else.",
"do_stmt","@23","while_stmt","@24","@25","for_stmt","@26","@27","return_stmt",
"return_stmt_kind","assign_stmt","array_reference",".expr.",".compounded_expr.",
"@28","expr_sc","expr","expr_or_compound","special_form","@29","@30","@31","expr_sequence",
"expr_sequence_elts","break_stmt","continue_stmt","simple_expr","atom","string_cst",
"type_cast","type_cast_type","method_invocation","rest_of_method_invocation",
"method_invocation_parts","method_invocation_part","tuple","tuple_field_list",
"identifier_list","semicolon","close_paren","close_bracket","new_class_name",
"class_name","resolved_class_name","missing_class_name","extension_name", NULL
};
#endif

static const short yyr1[] = {     0,
    85,    85,    86,    86,    86,    86,    86,    88,    89,    87,
    91,    92,    93,    90,    95,    96,    94,    98,    99,   100,
    97,   101,   102,   101,   103,   103,   104,   104,   104,   105,
   105,   105,   106,   106,   106,   107,   107,   108,   109,   109,
   109,   109,   110,   111,   111,   112,   112,   113,   113,   113,
   113,   114,   114,   114,   115,   115,   116,   117,   117,   117,
   117,   118,   120,   119,   122,   123,   121,   124,   124,   125,
   125,   125,   125,   125,   125,   125,   125,   125,   126,   126,
   127,   127,   128,   128,   129,   129,   130,   130,   131,   131,
   132,   132,   132,   133,   133,   133,   133,   133,   133,   133,
   133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
   133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
   133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
   133,   134,   134,   135,   136,   136,   136,   137,   138,   139,
   138,   141,   140,   143,   142,   144,   144,   145,   145,   146,
   147,   147,   147,   149,   148,   148,   148,   151,   150,   152,
   152,   153,   153,   155,   156,   157,   154,   158,   158,   160,
   159,   162,   163,   161,   165,   166,   164,   167,   167,   168,
   168,   169,   169,   169,   169,   169,   169,   169,   170,   170,
   171,   171,   172,   173,   172,   174,   174,   174,   174,   174,
   175,   175,   175,   175,   175,   175,   176,   176,   178,   177,
   179,   180,   177,   177,   181,   182,   182,   183,   183,   184,
   184,   185,   185,   185,   185,   185,   185,   185,   185,   185,
   185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
   185,   185,   185,   185,   185,   185,   185,   185,   185,   186,
   186,   186,   186,   186,   186,   186,   186,   187,   188,   188,
   188,   189,   189,   190,   190,   190,   190,   190,   190,   191,
   191,   192,   192,   193,   194,   194,   195,   195,   195,   195,
   196,   196,   197,   197,   198,   198,   199,   199,   200,   201,
   202,   202,   202,   203,   203,   203,   204,   204
};

static const short yyr2[] = {     0,
     0,     2,     2,     2,     2,     2,     1,     0,     0,    12,
     0,     0,     0,    13,     0,     0,    12,     0,     0,     0,
    13,     0,     0,     4,     0,     3,     3,     4,     5,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     4,     4,     3,     1,     3,     0,     2,     1,     2,     3,
     4,     1,     4,     4,     0,     1,     2,     0,     2,     2,
     2,     2,     0,     3,     0,     0,     7,     0,     1,     0,
     2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
     0,     2,     0,     2,     0,     1,     1,     2,     3,     5,
     1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     3,     0,     1,     2,     3,     1,     0,
     2,     0,     4,     0,     4,     0,     1,     1,     2,     1,
     2,     1,     1,     0,     4,     1,     1,     0,     3,     1,
     3,     1,     3,     0,     0,     0,     7,     0,     2,     0,
     6,     0,     0,     5,     0,     0,    11,     2,     1,     1,
     1,     3,     2,     2,     2,     2,     3,     3,     4,     4,
     0,     1,     0,     0,     2,     1,     1,     1,     1,     2,
     1,     1,     1,     1,     1,     1,     1,     1,     0,     4,
     0,     0,     5,     3,     3,     1,     3,     1,     2,     1,
     2,     1,     1,     2,     2,     2,     2,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     5,     4,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
     4,     1,     1,     4,     4,     4,     7,     2,     3,     1,
     1,     1,     2,     2,     3,     3,     1,     0,     3,     2,
     1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     3,     3,     1,     1,     3,     1,     1
};

static const short yydefact[] = {     1,
     0,    68,    68,     7,     2,     0,     0,     0,     0,    69,
    70,    70,   284,   283,     3,     5,     4,     6,     0,     0,
     0,     0,    76,    78,    77,    73,    71,    72,    74,    75,
     0,     0,     0,   291,    55,   289,    55,    55,    55,     0,
     0,     0,    11,    56,    18,     8,    15,   293,   292,   297,
   298,    57,    46,    46,    46,    46,     0,    12,    19,     9,
    16,     0,     0,     0,   295,    47,    48,   294,   290,    52,
    22,    22,    22,    22,     0,     0,    49,     0,     0,    23,
    13,    20,    58,    58,     0,     0,   296,     0,    50,    25,
   135,   135,     0,     0,    54,    53,    51,    70,     0,    65,
   136,    65,    61,    10,    59,     0,    70,    60,    17,    70,
    24,     0,     0,     0,     0,    40,    30,     0,     0,    32,
    31,    39,    14,   137,    63,    21,    62,    68,     0,    26,
     0,     0,     0,     0,    38,    44,     0,   138,     0,     0,
     0,     0,   281,    27,     0,     0,     0,    43,    64,     0,
   139,    34,    33,    35,    85,    66,    28,     0,     0,    41,
    42,    45,   142,   141,     0,     0,    86,    81,     0,   218,
   220,   181,     0,   211,     0,   253,   254,     0,     0,   258,
   252,   250,   263,   180,     0,     0,     0,     0,     0,   262,
   203,   179,   202,   223,    29,   206,   205,   204,   201,   222,
   251,   257,     0,   256,   255,   282,     0,     0,    96,    98,
    99,   100,   101,   102,   103,   105,   106,   107,   108,   104,
   109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    97,    95,   127,   125,
   126,   128,   129,    94,   131,   130,    93,    80,    87,     0,
    91,     0,    83,   227,   219,   221,     0,   209,     0,     0,
   183,   185,   268,   224,   225,   226,     0,     0,   144,   208,
   207,     0,    39,     0,   277,     0,   178,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   184,   186,     0,     0,     0,   164,   170,     0,   172,    30,
   152,     0,   158,    32,     0,     0,   148,   150,   153,     0,
     0,   196,   198,   199,   197,   156,     0,   157,   134,    88,
    91,    36,    37,     0,    92,     0,   201,     0,    67,   216,
     0,     0,   212,   214,   269,     0,   270,     0,   271,   272,
     0,     0,     0,   276,   280,   275,   188,   241,   243,   240,
   242,   245,   246,   247,   233,   234,   235,     0,   239,   244,
   238,   237,   236,   231,   232,   228,   229,   230,     0,     0,
   187,   182,     0,     0,     0,     0,     0,   194,     0,     0,
   143,   149,     0,   151,   200,   132,    89,   133,   201,     0,
   215,   210,     0,     0,   274,   288,   287,   266,     0,   273,
     0,   264,   265,   279,   249,     0,   190,   189,   261,   260,
   259,   165,     0,     0,     0,   173,   162,   159,   160,     0,
     0,   217,   213,   286,   285,     0,   145,   248,     0,     0,
   175,   195,     0,     0,     0,   155,    90,     0,   166,     0,
   191,   174,   163,   161,   267,   168,   171,     0,   192,     0,
   167,   176,   169,   194,     0,     0,   177,     0,     0
};

static const short yydefgoto[] = {     1,
     5,     6,    55,    73,     7,    53,    71,    91,     8,    56,
    74,     9,    54,    72,    92,    81,    90,    98,   112,   313,
   155,   334,   136,   190,   121,   137,    58,    66,    67,    43,
    44,    93,   105,   124,   139,   106,   107,   168,    11,    19,
   156,   253,   339,   166,   248,   249,   347,   331,   397,   167,
   100,   101,   149,   150,   164,   207,   270,   351,   315,   316,
   317,   318,   319,   320,   321,   390,   428,   429,   322,   386,
   439,   456,   461,   323,   387,   324,   389,   443,   325,   451,
   464,   191,   192,   193,   194,   458,   424,   425,   326,   327,
   275,   196,   342,   259,   403,   258,   341,   197,   198,   199,
   200,   201,   202,   203,   204,   348,   349,   350,   205,   276,
   144,   328,   436,   408,    35,   122,    69,    70,    52
};

static const short yypact[] = {-32768,
    51,    22,    22,-32768,-32768,    24,    24,    24,    24,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   461,   600,
    92,    92,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    92,    92,   -47,   -38,    76,-32768,    76,    76,    76,     2,
    46,   144,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    43,    43,    43,    43,   131,-32768,-32768,-32768,
-32768,    50,    61,    54,    52,    62,-32768,-32768,-32768,-32768,
   123,   123,   123,   123,   175,   175,-32768,   180,   143,-32768,
-32768,-32768,-32768,-32768,    72,   109,-32768,    54,-32768,-32768,
   154,   154,   242,   919,-32768,-32768,-32768,     0,   137,   201,
-32768,   208,-32768,-32768,-32768,    24,-32768,-32768,-32768,-32768,
-32768,    24,  1153,   134,   157,-32768,-32768,   137,   186,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   410,  1250,-32768,
   192,   194,   228,   228,-32768,-32768,    32,-32768,    29,   203,
   194,   196,-32768,   204,   198,   200,   137,-32768,-32768,   195,
-32768,-32768,-32768,-32768,   205,-32768,   204,  1086,   233,-32768,
-32768,-32768,-32768,-32768,   194,  1306,-32768,   265,  1086,  1086,
  1086,-32768,   212,-32768,   212,-32768,-32768,    71,    71,-32768,
   -13,-32768,-32768,-32768,  1086,  1086,  1086,   798,   399,-32768,
-32768,  1086,-32768,   232,  1334,-32768,-32768,-32768,-32768,   171,
-32768,-32768,   215,-32768,-32768,-32768,   534,    37,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1306,-32768,   332,
    53,  1086,   276,   223,  1334,  1334,  1023,-32768,   212,  1086,
-32768,-32768,-32768,   223,   223,   223,   222,   975,-32768,-32768,
  1334,  1306,  1306,   225,-32768,    55,  1334,  1086,  1086,  1086,
  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,
  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,   303,
-32768,-32768,  1086,  1086,   861,-32768,-32768,   227,-32768,   229,
-32768,   462,-32768,   231,   236,   601,-32768,-32768,-32768,   251,
    24,-32768,-32768,-32768,-32768,-32768,  1130,-32768,-32768,-32768,
   252,-32768,-32768,   -26,-32768,  1334,    25,  1086,-32768,-32768,
   -49,  1086,-32768,  1334,-32768,   228,  1086,     9,  1306,-32768,
   534,     9,     9,-32768,  1023,-32768,  1334,  1421,  1421,  1421,
  1421,  1404,  1390,  1348,   487,   487,   487,  1177,  1421,  1421,
   457,   501,   352,   257,   257,   223,   223,   223,   237,   -42,
  1334,  1334,   246,   259,  1224,   238,   668,    42,   238,   272,
-32768,-32768,   534,-32768,-32768,-32768,   270,-32768,    39,  1023,
-32768,  1334,  1086,    23,  1334,-32768,-32768,-32768,  1086,-32768,
   254,-32768,-32768,-32768,-32768,  1086,-32768,-32768,-32768,-32768,
-32768,-32768,   322,    24,  1023,-32768,   284,   295,-32768,   282,
  1086,-32768,  1334,-32768,-32768,  1306,-32768,  1334,   735,   238,
-32768,-32768,   668,  1086,   272,-32768,  1334,     9,-32768,    24,
  1086,-32768,  1334,-32768,-32768,   346,-32768,    24,  1334,   735,
-32768,-32768,-32768,   285,   286,   668,-32768,   370,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   135,-32768,-32768,-32768,   -57,
-32768,-32768,   226,   -95,-32768,-32768,   290,-32768,   140,   312,
-32768,   288,-32768,-32768,-32768,   142,-32768,-32768,     4,    -3,
-32768,-32768,-32768,-32768,-32768,   126,  -160,   210,-32768,    44,
   289,   -18,-32768,-32768,-32768,-32768,-32768,-32768,  -324,-32768,
  -263,-32768,  -317,-32768,-32768,-32768,-32768,   -62,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -87,-32768,-32768,  -122,
  -171,-32768,-32768,-32768,-32768,  -163,-32768,-32768,-32768,  -244,
    48,-32768,-32768,-32768,-32768,  -257,-32768,    36,  -176,    88,
   -68,    -6,-32768,  -331,   165,   -44,   245,   187,-32768
};


#define	YYLAST		1500


static const short yytable[] = {    15,
    16,    17,    18,   120,   263,   250,    12,   337,    20,   406,
   400,   260,    68,   110,   352,   353,   272,   120,   355,    68,
   412,   413,   120,   434,    13,   -82,   411,    10,   396,    13,
    68,    68,   401,   120,    68,   195,    40,   145,   146,   -84,
   418,   119,  -193,    68,   120,    41,   254,   255,   256,   -82,
   468,   120,   392,   -79,   165,   132,    62,     2,    48,     3,
   135,    63,   264,   265,   266,   271,   271,   189,   430,   277,
    40,   141,   157,   114,   108,   108,   -79,   -79,   115,   111,
    42,   116,   154,    14,   -82,   340,   -82,   250,    14,   135,
  -140,   407,   147,   399,   113,   343,   208,   159,   -84,   127,
   -84,  -193,    49,   128,   435,   130,   129,    57,    65,     4,
    34,   314,   -79,   148,   -79,   355,   455,   335,   329,   176,
   177,   449,    79,   423,   180,   181,   182,    34,   183,   336,
    75,   140,   151,    62,   271,    78,   356,   344,    63,   114,
    64,    76,   463,   273,   115,    62,    33,   116,    34,   188,
    63,   189,    88,    95,   120,   357,   358,   359,   360,   361,
   362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
   372,   373,   374,   375,   376,   377,   378,   271,   448,   452,
   381,   382,   385,   414,    80,    65,    37,    34,   409,   271,
    96,    33,   333,    34,   117,    38,    39,    65,    50,    34,
    51,    99,   467,    77,   123,   114,    82,    83,    84,   422,
   115,   126,   426,   116,   133,   336,   314,   118,    89,   402,
   314,   301,   302,   303,   405,   261,   262,    97,   432,    65,
   114,    34,   271,   304,    87,   115,    48,   134,   116,   152,
   138,   125,   103,   125,   -65,   104,   142,   -65,   143,   -65,
   404,   153,   -65,   442,   135,   314,   163,    33,   158,    34,
   117,    85,    86,   450,   159,    36,    36,   -65,   -65,   -65,
   -65,   -65,   -65,   -65,   -65,    36,    36,   271,   -65,   160,
   433,   161,    33,   118,    34,   165,   405,   206,   252,    99,
   -65,   314,   257,   438,   278,   305,   -65,   314,   -65,   -65,
   338,   300,   271,   379,   345,   114,   354,   388,   447,  -263,
   115,  -262,   393,   116,   394,   391,   335,   169,   189,   417,
   395,   453,   -65,   170,   171,   172,   427,   419,   459,   297,
   298,   299,   431,   437,   114,   300,   173,   174,   175,   115,
   420,   440,   116,    59,    60,    61,   444,   314,    45,    46,
    47,   176,   177,   178,   179,   445,   180,   181,   182,    34,
   183,   446,   460,  -278,   269,   184,  -193,   466,   332,   469,
   314,    94,   162,   330,   185,   251,   465,   398,   186,   187,
   102,   188,   454,   189,   410,  -278,    33,   380,    34,   117,
     0,     0,     0,     0,     0,     0,   286,   287,   288,   274,
     0,   114,     0,     0,     0,     0,   115,     0,     0,   116,
     0,     0,   118,   169,     0,    10,     0,   441,     0,   170,
   171,   172,   295,   296,   297,   298,   299,     0,     0,     0,
   300,     0,   173,   174,   175,    23,    24,    25,    26,    27,
    28,    29,    30,   457,     0,     0,     0,   176,   177,   178,
   179,   462,   180,   181,   182,    34,   183,     0,     0,  -278,
   269,   184,   274,    21,   114,     0,     0,     0,    22,   115,
   185,     0,   116,     0,   186,   187,   169,   188,     0,   189,
  -278,     0,   170,   171,   172,     0,    23,    24,    25,    26,
    27,    28,    29,    30,     0,   173,   174,   175,     0,     0,
     0,   286,   287,   288,     0,     0,     0,     0,     0,     0,
   176,   177,   178,   179,     0,   180,   181,   182,    34,   310,
     0,     0,  -278,   269,   184,   293,   294,   295,   296,   297,
   298,   299,     0,   185,    13,   300,   114,   186,   187,     0,
   188,   115,   312,  -278,   116,   286,   287,   288,   169,   306,
     0,   307,   308,   309,   170,   171,   172,   295,   296,   297,
   298,   299,     0,     0,     0,   300,     0,   173,   174,   175,
   294,   295,   296,   297,   298,   299,     0,     0,     0,   300,
     0,     0,   176,   177,   178,   179,     0,   180,   181,   182,
    34,   310,   311,    14,     0,  -154,   184,     0,     0,     0,
     0,    13,    31,   114,     0,   185,     0,    32,   115,   186,
   187,   116,   188,  -146,   312,   169,   306,     0,   307,   308,
   309,   170,   171,   172,     0,    23,    24,    25,    26,    27,
    28,    29,    30,     0,   173,   174,   175,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   176,
   177,   178,   179,     0,   180,   181,   182,    34,   310,   311,
    14,     0,  -154,   184,     0,     0,     0,     0,    13,     0,
   114,     0,   185,     0,     0,   115,   186,   187,   116,   188,
  -147,   312,   169,   306,     0,   307,   308,   309,   170,   171,
   172,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   173,   174,   175,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   176,   177,   178,   179,
     0,   180,   181,   182,    34,   310,   311,    14,     0,  -154,
   184,     0,     0,     0,     0,    13,     0,   114,     0,   185,
     0,     0,   115,   186,   187,   116,   188,     0,   312,   169,
   306,     0,   307,   308,   309,   170,   171,   172,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   173,   174,
   175,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   176,   177,   178,   179,     0,   180,   181,
   182,    34,   183,     0,    14,     0,  -154,   184,   267,     0,
   114,     0,     0,     0,     0,   115,   185,     0,   116,   268,
   186,   187,   169,   188,     0,   189,     0,     0,   170,   171,
   172,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   173,   174,   175,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   176,   177,   178,   179,
     0,   180,   181,   182,    34,   183,     0,     0,     0,   269,
   184,   383,     0,   114,     0,     0,     0,     0,   115,   185,
     0,   116,   384,   186,   187,   169,   188,     0,   189,     0,
     0,   170,   171,   172,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   173,   174,   175,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   176,
   177,   178,   179,     0,   180,   181,   182,    34,   183,   103,
     0,   -65,   109,   184,   -65,     0,   -65,     0,     0,   -65,
     0,     0,   185,     0,     0,     0,   186,   187,     0,   188,
     0,   189,     0,     0,   -65,   -65,   -65,   -65,   -65,   -65,
   -65,   -65,     0,     0,     0,   -65,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    99,   -65,     0,     0,
     0,     0,     0,   -65,     0,   -65,   -65,   209,   210,   211,
   212,   213,   214,   215,   216,   217,   218,   219,   220,     0,
   221,   222,   223,   224,   225,   226,   227,   228,     0,   -65,
   229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   241,   242,   243,   114,     0,     0,     0,   244,
   115,   245,   246,   116,     0,     0,     0,   169,     0,   247,
     0,     0,     0,   170,   171,   172,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   346,   173,   174,   175,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   176,   177,   178,   179,     0,   180,   181,   182,    34,
   183,     0,     0,     0,   269,   184,     0,     0,   114,     0,
     0,     0,     0,   115,   185,     0,   116,     0,   186,   187,
   169,   188,     0,   189,     0,     0,   170,   171,   172,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   173,
   174,   175,     0,     0,     0,     0,     0,     0,     0,     0,
    13,     0,     0,     0,   176,   177,   178,   179,     0,   180,
   181,   182,    34,   183,     0,     0,     0,     0,   184,     0,
     0,     0,     0,     0,     0,   114,     0,   185,     0,     0,
   115,   186,   187,   116,   188,   131,   189,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,   415,    23,    24,
    25,    26,    27,    28,    29,    30,     0,     0,     0,    14,
     0,     0,     0,   289,     0,   290,   291,   292,   293,   294,
   295,   296,   297,   298,   299,     0,     0,    33,   300,    34,
   117,     0,     0,     0,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
   289,   416,   290,   291,   292,   293,   294,   295,   296,   297,
   298,   299,   114,     0,     0,   300,     0,   115,     0,     0,
   116,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,    23,    24,    25,    26,    27,
    28,    29,    30,     0,     0,     0,     0,   289,     0,   290,
   291,   292,   293,   294,   295,   296,   297,   298,   299,     0,
     0,     0,   300,     0,    33,   421,    34,   117,   209,   210,
   211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     0,   221,   222,   223,   224,   225,   226,   227,   228,     0,
   118,   229,   230,   231,   232,   233,   234,   235,   236,   237,
   238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   241,   242,   243,     0,     0,     0,     0,
   244,     0,   245,   246,     0,     0,     0,     0,     0,     0,
   247,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   279,   280,   281,   282,   283,
   284,     0,   286,   287,   288,     0,     0,   289,     0,   290,
   291,   292,   293,   294,   295,   296,   297,   298,   299,     0,
     0,     0,   300,   290,   291,   292,   293,   294,   295,   296,
   297,   298,   299,     0,     0,     0,   300,   279,   280,   281,
   282,   283,     0,     0,   286,   287,   288,     0,     0,     0,
     0,   279,   280,   281,   282,     0,     0,     0,   286,   287,
   288,     0,     0,     0,     0,   290,   291,   292,   293,   294,
   295,   296,   297,   298,   299,   286,   287,   288,   300,   290,
   291,   292,   293,   294,   295,   296,   297,   298,   299,     0,
     0,     0,   300,     0,     0,     0,     0,     0,   292,   293,
   294,   295,   296,   297,   298,   299,     0,     0,     0,   300
};

static const short yycheck[] = {     6,
     7,     8,     9,    99,   181,   166,     3,   252,    12,     1,
    60,   175,    57,    14,   272,   273,   188,   113,    61,    64,
   352,   353,   118,     1,     1,     1,   351,     6,    55,     1,
    75,    76,    82,   129,    79,   158,    84,   133,   134,     1,
    83,    99,     1,    88,   140,    84,   169,   170,   171,    25,
     0,   147,   316,     1,    81,   113,     3,     7,    57,     9,
   118,     8,   185,   186,   187,   188,   189,    81,   393,   192,
    84,   129,   141,     3,    93,    94,    24,    25,     8,    80,
     5,    11,   140,    60,    60,   257,    62,   248,    60,   147,
    62,    83,    61,   338,    98,   259,   165,    61,    60,   106,
    62,    60,    57,   107,    82,   112,   110,    65,    55,    59,
    57,   207,    60,    82,    62,    61,   448,    65,    82,    49,
    50,   439,    61,   387,    54,    55,    56,    57,    58,   252,
    81,   128,   139,     3,   257,    84,    82,   260,     8,     3,
    10,    81,   460,   188,     8,     3,    55,    11,    57,    79,
     8,    81,    10,    82,   250,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
   293,   294,   295,   296,   297,   298,   299,   300,   436,   443,
   303,   304,   305,   355,    62,    55,    22,    57,   349,   312,
    82,    55,   250,    57,    58,    31,    32,    55,    55,    57,
    57,    48,   466,    64,     4,     3,    72,    73,    74,   386,
     8,     4,   389,    11,    81,   338,   312,    81,    79,   342,
   316,    51,    52,    53,   347,   178,   179,    88,   400,    55,
     3,    57,   355,    63,    55,     8,    57,    81,    11,    37,
    55,   100,     1,   102,     3,     4,    55,     6,    55,     8,
   346,    49,    11,   425,   312,   351,    62,    55,    63,    57,
    58,    75,    76,   440,    61,    21,    22,    26,    27,    28,
    29,    30,    31,    32,    33,    31,    32,   400,    37,    82,
   403,    82,    55,    81,    57,    81,   409,    55,    24,    48,
    49,   387,    81,   416,    63,    81,    55,   393,    57,    58,
    25,    79,   425,     1,    83,     3,    82,    81,   431,    81,
     8,    81,    62,    11,   321,    80,    65,    15,    81,    83,
   327,   444,    81,    21,    22,    23,    55,    82,   451,    73,
    74,    75,    63,    80,     3,    79,    34,    35,    36,     8,
    82,    20,    11,    54,    55,    56,    63,   443,    37,    38,
    39,    49,    50,    51,    52,    61,    54,    55,    56,    57,
    58,    80,    17,    61,    62,    63,    82,    82,    37,     0,
   466,    84,   147,   248,    72,   166,   464,   334,    76,    77,
    92,    79,   445,    81,   349,    83,    55,   300,    57,    58,
    -1,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,     1,
    -1,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
    -1,    -1,    81,    15,    -1,     6,    -1,   424,    -1,    21,
    22,    23,    71,    72,    73,    74,    75,    -1,    -1,    -1,
    79,    -1,    34,    35,    36,    26,    27,    28,    29,    30,
    31,    32,    33,   450,    -1,    -1,    -1,    49,    50,    51,
    52,   458,    54,    55,    56,    57,    58,    -1,    -1,    61,
    62,    63,     1,     3,     3,    -1,    -1,    -1,     8,     8,
    72,    -1,    11,    -1,    76,    77,    15,    79,    -1,    81,
    82,    -1,    21,    22,    23,    -1,    26,    27,    28,    29,
    30,    31,    32,    33,    -1,    34,    35,    36,    -1,    -1,
    -1,    45,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,
    49,    50,    51,    52,    -1,    54,    55,    56,    57,    58,
    -1,    -1,    61,    62,    63,    69,    70,    71,    72,    73,
    74,    75,    -1,    72,     1,    79,     3,    76,    77,    -1,
    79,     8,    81,    82,    11,    45,    46,    47,    15,    16,
    -1,    18,    19,    20,    21,    22,    23,    71,    72,    73,
    74,    75,    -1,    -1,    -1,    79,    -1,    34,    35,    36,
    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
    -1,    -1,    49,    50,    51,    52,    -1,    54,    55,    56,
    57,    58,    59,    60,    -1,    62,    63,    -1,    -1,    -1,
    -1,     1,     3,     3,    -1,    72,    -1,     8,     8,    76,
    77,    11,    79,    80,    81,    15,    16,    -1,    18,    19,
    20,    21,    22,    23,    -1,    26,    27,    28,    29,    30,
    31,    32,    33,    -1,    34,    35,    36,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
    50,    51,    52,    -1,    54,    55,    56,    57,    58,    59,
    60,    -1,    62,    63,    -1,    -1,    -1,    -1,     1,    -1,
     3,    -1,    72,    -1,    -1,     8,    76,    77,    11,    79,
    80,    81,    15,    16,    -1,    18,    19,    20,    21,    22,
    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    34,    35,    36,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,
    -1,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
    63,    -1,    -1,    -1,    -1,     1,    -1,     3,    -1,    72,
    -1,    -1,     8,    76,    77,    11,    79,    -1,    81,    15,
    16,    -1,    18,    19,    20,    21,    22,    23,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,
    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    49,    50,    51,    52,    -1,    54,    55,
    56,    57,    58,    -1,    60,    -1,    62,    63,     1,    -1,
     3,    -1,    -1,    -1,    -1,     8,    72,    -1,    11,    12,
    76,    77,    15,    79,    -1,    81,    -1,    -1,    21,    22,
    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    34,    35,    36,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,
    -1,    54,    55,    56,    57,    58,    -1,    -1,    -1,    62,
    63,     1,    -1,     3,    -1,    -1,    -1,    -1,     8,    72,
    -1,    11,    12,    76,    77,    15,    79,    -1,    81,    -1,
    -1,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    34,    35,    36,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
    50,    51,    52,    -1,    54,    55,    56,    57,    58,     1,
    -1,     3,     4,    63,     6,    -1,     8,    -1,    -1,    11,
    -1,    -1,    72,    -1,    -1,    -1,    76,    77,    -1,    79,
    -1,    81,    -1,    -1,    26,    27,    28,    29,    30,    31,
    32,    33,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    -1,
    -1,    -1,    -1,    55,    -1,    57,    58,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
    16,    17,    18,    19,    20,    21,    22,    23,    -1,    81,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    48,    49,    50,     3,    -1,    -1,    -1,    55,
     8,    57,    58,    11,    -1,    -1,    -1,    15,    -1,    65,
    -1,    -1,    -1,    21,    22,    23,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    81,    34,    35,    36,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    49,    50,    51,    52,    -1,    54,    55,    56,    57,
    58,    -1,    -1,    -1,    62,    63,    -1,    -1,     3,    -1,
    -1,    -1,    -1,     8,    72,    -1,    11,    -1,    76,    77,
    15,    79,    -1,    81,    -1,    -1,    21,    22,    23,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
    35,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     1,    -1,    -1,    -1,    49,    50,    51,    52,    -1,    54,
    55,    56,    57,    58,    -1,    -1,    -1,    -1,    63,    -1,
    -1,    -1,    -1,    -1,    -1,     3,    -1,    72,    -1,    -1,
     8,    76,    77,    11,    79,    13,    81,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,     1,    26,    27,
    28,    29,    30,    31,    32,    33,    -1,    -1,    -1,    60,
    -1,    -1,    -1,    64,    -1,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    -1,    -1,    55,    79,    57,
    58,    -1,    -1,    -1,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,     3,    -1,    -1,    79,    -1,     8,    -1,    -1,
    11,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    -1,    -1,    -1,    -1,    26,    27,    28,    29,    30,
    31,    32,    33,    -1,    -1,    -1,    -1,    64,    -1,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
    -1,    -1,    79,    -1,    55,    82,    57,    58,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    -1,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
    81,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    48,    49,    50,    -1,    -1,    -1,    -1,
    55,    -1,    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,
    65,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    -1,    -1,    -1,    -1,    38,    39,    40,    41,    42,
    43,    -1,    45,    46,    47,    -1,    -1,    64,    -1,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
    -1,    -1,    79,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    -1,    -1,    -1,    79,    38,    39,    40,
    41,    42,    -1,    -1,    45,    46,    47,    -1,    -1,    -1,
    -1,    38,    39,    40,    41,    -1,    -1,    -1,    45,    46,
    47,    -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    45,    46,    47,    79,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
    -1,    -1,    79,    -1,    -1,    -1,    -1,    -1,    68,    69,
    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/misc/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/share/misc/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 7:
#line 1249 "parse.y"
{
	      if (of)
		[yyvsp[0].v compileStatement];
	    ;
    break;}
case 8:
#line 1258 "parse.y"
{
	      set_current_either (yyvsp[-1].v, yyvsp[0].v, 1, yyvsp[-4].v, yyvsp[-3].i, 0);
	    ;
    break;}
case 9:
#line 1262 "parse.y"
{
	      check_supers ();
	    ;
    break;}
case 10:
#line 1267 "parse.y"
{
	      pop_report_context ();
	      in_what = GLOBAL_SCOPE;
	    ;
    break;}
case 11:
#line 1276 "parse.y"
{
	      set_current_either (yyvsp[-1].v, yyvsp[0].v, 1, yyvsp[-4].v, yyvsp[-3].i, 1);
	    ;
    break;}
case 12:
#line 1280 "parse.y"
{
	      check_supers ();
	    ;
    break;}
case 13:
#line 1284 "parse.y"
{
	      if (of)
		[C_EXT_SEMANTICS startCompile];
	    ;
    break;}
case 14:
#line 1289 "parse.y"
{
	      [C_EXT_SEMANTICS checkImplementation];
	      if (of)
		[C_EXT_SEMANTICS endCompile];
	      pop_report_context ();
	      in_what = GLOBAL_SCOPE;
	    ;
    break;}
case 15:
#line 1301 "parse.y"
{
	      set_current_either (yyvsp[-1].v, yyvsp[0].v, 0, yyvsp[-4].v, yyvsp[-3].i, 0);
	    ;
    break;}
case 16:
#line 1305 "parse.y"
{
	      check_supers ();
	    ;
    break;}
case 17:
#line 1310 "parse.y"
{
	      pop_report_context ();
	      in_what = GLOBAL_SCOPE;
	    ;
    break;}
case 18:
#line 1319 "parse.y"
{
	      set_current_either (yyvsp[-1].v, yyvsp[0].v, 0, yyvsp[-4].v, yyvsp[-3].i, 1);
	    ;
    break;}
case 19:
#line 1323 "parse.y"
{
	      check_supers ();
	    ;
    break;}
case 20:
#line 1327 "parse.y"
{
	      if (of)
		[C_EXT_SEMANTICS startCompile];
	    ;
    break;}
case 21:
#line 1332 "parse.y"
{
	      [C_EXT_SEMANTICS checkImplementation];
	      if (of)
		[C_EXT_SEMANTICS endCompile];
	      pop_report_context ();
	      in_what = GLOBAL_SCOPE;
	    ;
    break;}
case 23:
#line 1344 "parse.y"
{
	      [C_EITHER_SEMANTICS setStatep];
	    ;
    break;}
case 27:
#line 1357 "parse.y"
{
	      if (yyvsp[-1].v)
		object_add_variables (yyvsp[-2].i, yyvsp[-1].v, yyvsp[0].v, 0);
	    ;
    break;}
case 28:
#line 1362 "parse.y"
{
	      if (yyvsp[-1].v)
		object_add_variables (yyvsp[-2].i, yyvsp[-1].v, yyvsp[0].v, 1);
	    ;
    break;}
case 29:
#line 1367 "parse.y"
{
	      if (in_what == IMPLEMENTATION_SCOPE)
		{
		  /* XXX Check consistency.  */
		}
	      else
		{
		  object_add_const (yyvsp[-4].i, yyvsp[-2].v, yyvsp[0].v);
		}
	    ;
    break;}
case 33:
#line 1386 "parse.y"
{ yyval.v = basic_type[BT_VOID]; ;
    break;}
case 34:
#line 1387 "parse.y"
{ yyval.v = the_dynamic_type; ;
    break;}
case 36:
#line 1392 "parse.y"
{ yyval.v = the_dynamic_type; ;
    break;}
case 39:
#line 1405 "parse.y"
{
	      yyval.v = [yyvsp[0].v semantics];
	    ;
    break;}
case 40:
#line 1409 "parse.y"
{
	      yyval.v = basic_type[BT_RECV];
	    ;
    break;}
case 41:
#line 1413 "parse.y"
{
	      yyval.v = [(OTMMeta *) yyvsp[-1].v itsClass];
	    ;
    break;}
case 42:
#line 1417 "parse.y"
{
	      yyval.v = [(OTMMeta *) yyvsp[-1].v instance];
	    ;
    break;}
case 43:
#line 1424 "parse.y"
{
	      if ([yyvsp[-1].v cdr])
		yyval.v = [CO_OTMTypeTuple typeTupleWithSequence: yyvsp[-1].v];
	      else
		yyval.v = [yyvsp[-1].v car];
	    ;
    break;}
case 44:
#line 1434 "parse.y"
{
	      yyval.v = CONS (yyvsp[0].v, nil);
	    ;
    break;}
case 45:
#line 1438 "parse.y"
{
	      yyval.v = [yyvsp[-2].v nconc: CONS (yyvsp[0].v, nil)];
	    ;
    break;}
case 48:
#line 1450 "parse.y"
{
	      do_add_super (yyvsp[0].v, 0);
	    ;
    break;}
case 49:
#line 1454 "parse.y"
{
	      do_add_super (yyvsp[0].v, 1);
	    ;
    break;}
case 50:
#line 1458 "parse.y"
{
	      do_add_super (yyvsp[0].v, 0);
	    ;
    break;}
case 51:
#line 1462 "parse.y"
{
	      do_add_super (yyvsp[0].v, 1);
	    ;
    break;}
case 53:
#line 1470 "parse.y"
{
	      yyval.v = CONS (nil, yyvsp[-1].v);
	    ;
    break;}
case 54:
#line 1474 "parse.y"
{
	      yyval.v = CONS (yyvsp[-1].v, nil);
	    ;
    break;}
case 55:
#line 1480 "parse.y"
{ yyval.v = NULL; ;
    break;}
case 57:
#line 1485 "parse.y"
{ yyval.v = yyvsp[0].v; ;
    break;}
case 61:
#line 1493 "parse.y"
{
	      error (@"parse error at `%s'", yytext);
	    ;
    break;}
case 62:
#line 1500 "parse.y"
{
	      add_method_decl (yyvsp[-1].v);
	      current_method = nil;
	    ;
    break;}
case 63:
#line 1508 "parse.y"
{
	      /* Don't set the current method if we're just reading an
                 interface.  */
	      current_method = of ? yyvsp[0].v : nil;
	    ;
    break;}
case 64:
#line 1514 "parse.y"
{
	      if (of && !NUM_ERRORS)
		[current_method compile];

	      current_method = nil;
	    ;
    break;}
case 65:
#line 1523 "parse.y"
{
	      next_tmp = 0;
	      next_arg = 2;
	    ;
    break;}
case 66:
#line 1528 "parse.y"
{
	      yyvsp[-2].i = mask_qualifiers (yyvsp[-2].i, (OQ_DEFERRED_MASK
					 | OQ_REDO_MASK | OQ_PROTECTION_MASK));

	      /* Check foreigness compared to what was declared for this
                 class.  */
	      if (current_either)
		{
		  id f = [C_EITHER_SEMANTICS foreign];

		  if (!yyvsp[-1].v)
		    {
		      if (f)
			yyvsp[-1].v = f;
		    }
		  else if (f == yyvsp[-1].v)
		    warning (@"repeated foreign qualifier");
		  else if (f)
		    error (@"foreign %# differs from class' %#", yyvsp[-1].v, f);
		}

	      [yyvsp[0].v setQualifiers: yyvsp[-2].i];
	      if (yyvsp[-1].v)
		{
		  if (Q_DEFERRED (yyvsp[-2].i))
		    error (@"deferred method can't be foreign");
		  else
		    [yyvsp[0].v setForeign: yyvsp[-1].v];
		}

	      current_method = yyvsp[0].v;
	    ;
    break;}
case 67:
#line 1561 "parse.y"
{
	      yyval.v = current_method;
	    ;
    break;}
case 68:
#line 1567 "parse.y"
{ yyval.v = 0; ;
    break;}
case 69:
#line 1569 "parse.y"
{
	      yyval.v = @"C";
	    ;
    break;}
case 70:
#line 1575 "parse.y"
{ yyval.i = 0; ;
    break;}
case 71:
#line 1577 "parse.y"
{
	      if (current_instance)
		error (@"static qualifier only allowed in classes");
	      else
		{
		  if (Q_STATIC (yyvsp[-1].i))
		    error (@"`static' repeated");
		  yyval.i = Q_SET_STATIC (yyvsp[-1].i, OQ_STATIC);
		}
	    ;
    break;}
case 72:
#line 1588 "parse.y"
{
	      if (Q_DEFERRED (yyvsp[-1].i))
		error (@"`deferred' repeated");
	      yyval.i = Q_SET_DEFERRED (yyvsp[-1].i, OQ_DEFERRED);
	    ;
    break;}
case 73:
#line 1594 "parse.y"
{
	      if (Q_MUTABLE (yyvsp[-1].i))
		error (@"`deferred' repeated");
	      yyval.i = Q_SET_MUTABLE (yyvsp[-1].i, OQ_MUTABLE);
	    ;
    break;}
case 74:
#line 1600 "parse.y"
{
	      if (Q_REDO (yyvsp[-1].i))
		error (@"conflicting qualifiers for `redefine'");
	      yyval.i = Q_SET_REDO (yyvsp[-1].i, OQ_REDEFINE);
	    ;
    break;}
case 75:
#line 1606 "parse.y"
{
	      if (Q_REDO (yyvsp[-1].i))
		error (@"conflicting qualifiers for `redeclare'");
	      yyval.i = Q_SET_REDO (yyvsp[-1].i, OQ_REDECLARE);
	    ;
    break;}
case 76:
#line 1612 "parse.y"
{
	      if (Q_PROTECTION (yyvsp[-1].i))
		error (@"conflicting qualifiers for `public'");
	      yyval.i = Q_SET_PROTECTION (yyvsp[-1].i, OQ_PUBLIC);
	    ;
    break;}
case 77:
#line 1618 "parse.y"
{
	      if (Q_PROTECTION (yyvsp[-1].i))
		error (@"conflicting qualifiers for `protected'");
	      yyval.i = Q_SET_PROTECTION (yyvsp[-1].i, OQ_PROTECTED);
	    ;
    break;}
case 78:
#line 1624 "parse.y"
{
	      if (Q_PROTECTION (yyvsp[-1].i))
		error (@"conflicting qualifiers for `private'");
	      yyval.i = Q_SET_PROTECTION (yyvsp[-1].i, OQ_PRIVATE);
	    ;
    break;}
case 79:
#line 1633 "parse.y"
{
	      yyval.v = yyvsp[-2].v ? [CO_OTMCustomMethod methodWithExtension: C_EXT_SEMANTICS
				   name: yyvsp[0].v returnType: yyvsp[-2].v flatp: NO] : nil;
	      [yyval.v setReturnVariables: yyvsp[-1].v];
	    ;
    break;}
case 80:
#line 1639 "parse.y"
{
	      yyval.v = (yyvsp[-2].v && yyvsp[0].v
		    ? [CO_OTMCustomMethod methodWithExtension: C_EXT_SEMANTICS
				 nameTypes: yyvsp[0].v returnType: yyvsp[-2].v flatp: NO] : nil);
	      [yyval.v setReturnVariables: yyvsp[-1].v];
	    ;
    break;}
case 82:
#line 1650 "parse.y"
{
	      if (current_method)
		[current_method setPrecondition: yyvsp[0].v];
	    ;
    break;}
case 84:
#line 1659 "parse.y"
{
	      if (current_method)
		[current_method setPostcondition: yyvsp[0].v];
	    ;
    break;}
case 85:
#line 1666 "parse.y"
{ yyval.v = nil; ;
    break;}
case 86:
#line 1667 "parse.y"
{ yyval.v = yyvsp[0].v; ;
    break;}
case 88:
#line 1673 "parse.y"
{
	      yyval.v = [yyvsp[-1].v nconc: yyvsp[0].v];
	    ;
    break;}
case 89:
#line 1680 "parse.y"
{
	      yyval.v = CONS (yyvsp[-2].v, digest_arguments (yyvsp[0].v, yyvsp[-1].v, 0));
	      yyval.v = CONS (yyval.v, nil);
	    ;
    break;}
case 90:
#line 1685 "parse.y"
{
	      yyval.v = CONS (yyvsp[-4].v, digest_arguments (yyvsp[-2].v, yyvsp[-3].v, yyvsp[0].v));
	      yyval.v = CONS (yyval.v, nil);
	    ;
    break;}
case 92:
#line 1694 "parse.y"
{
	      yyval.v = unique_identifier ([CO_TLString stringWithFormat: @"%@:",
						yyvsp[-1].v]);
	    ;
    break;}
case 93:
#line 1699 "parse.y"
{
	      yyval.v = unique_identifier_colon;
	    ;
    break;}
case 95:
#line 1706 "parse.y"
{ yyval.v = unique_identifier (@"bind"); ;
    break;}
case 96:
#line 1707 "parse.y"
{ yyval.v = unique_identifier (@"class"); ;
    break;}
case 97:
#line 1708 "parse.y"
{ yyval.v = unique_identifier (@"catch"); ;
    break;}
case 98:
#line 1709 "parse.y"
{ yyval.v = unique_identifier (@"end"); ;
    break;}
case 99:
#line 1710 "parse.y"
{ yyval.v = unique_identifier (@"extension"); ;
    break;}
case 100:
#line 1711 "parse.y"
{ yyval.v = unique_identifier (@"extern"); ;
    break;}
case 101:
#line 1712 "parse.y"
{ yyval.v = unique_identifier (@"implementation"); ;
    break;}
case 102:
#line 1713 "parse.y"
{ yyval.v = unique_identifier (@"instance"); ;
    break;}
case 103:
#line 1714 "parse.y"
{ yyval.v = unique_identifier (@"interface"); ;
    break;}
case 104:
#line 1715 "parse.y"
{ yyval.v = unique_identifier (@"local"); ;
    break;}
case 105:
#line 1716 "parse.y"
{ yyval.v = unique_identifier (@"posing"); ;
    break;}
case 106:
#line 1717 "parse.y"
{ yyval.v = unique_identifier (@"id"); ;
    break;}
case 107:
#line 1718 "parse.y"
{ yyval.v = unique_identifier (@"super"); ;
    break;}
case 108:
#line 1719 "parse.y"
{ yyval.v = unique_identifier (@"const"); ;
    break;}
case 109:
#line 1720 "parse.y"
{ yyval.v = unique_identifier (@"if"); ;
    break;}
case 110:
#line 1721 "parse.y"
{ yyval.v = unique_identifier (@"else"); ;
    break;}
case 111:
#line 1722 "parse.y"
{ yyval.v = unique_identifier (@"do"); ;
    break;}
case 112:
#line 1723 "parse.y"
{ yyval.v = unique_identifier (@"for"); ;
    break;}
case 113:
#line 1724 "parse.y"
{ yyval.v = unique_identifier (@"while"); ;
    break;}
case 114:
#line 1725 "parse.y"
{ yyval.v = unique_identifier (@"break"); ;
    break;}
case 115:
#line 1726 "parse.y"
{ yyval.v = unique_identifier (@"continue"); ;
    break;}
case 116:
#line 1727 "parse.y"
{ yyval.v = unique_identifier (@"return"); ;
    break;}
case 117:
#line 1728 "parse.y"
{ yyval.v = unique_identifier (@"public"); ;
    break;}
case 118:
#line 1729 "parse.y"
{ yyval.v = unique_identifier (@"private"); ;
    break;}
case 119:
#line 1730 "parse.y"
{ yyval.v = unique_identifier (@"protected"); ;
    break;}
case 120:
#line 1731 "parse.y"
{ yyval.v = unique_identifier (@"mutable"); ;
    break;}
case 121:
#line 1732 "parse.y"
{ yyval.v = unique_identifier (@"static"); ;
    break;}
case 122:
#line 1733 "parse.y"
{ yyval.v = unique_identifier (@"deferred"); ;
    break;}
case 123:
#line 1734 "parse.y"
{ yyval.v = unique_identifier (@"redefine"); ;
    break;}
case 124:
#line 1735 "parse.y"
{ yyval.v = unique_identifier (@"redeclare"); ;
    break;}
case 125:
#line 1736 "parse.y"
{ yyval.v = unique_identifier (@"dynamic"); ;
    break;}
case 126:
#line 1737 "parse.y"
{ yyval.v = unique_identifier (@"typedef"); ;
    break;}
case 127:
#line 1738 "parse.y"
{ yyval.v = unique_identifier (@"unwind"); ;
    break;}
case 128:
#line 1739 "parse.y"
{ yyval.v = unique_identifier (@"void"); ;
    break;}
case 129:
#line 1740 "parse.y"
{ yyval.v = unique_identifier (@"nil"); ;
    break;}
case 130:
#line 1741 "parse.y"
{ yyval.v = unique_identifier ([(OTMMeta *) yyvsp[0].v typeName]); ;
    break;}
case 131:
#line 1743 "parse.y"
{
	      yyval.v = unique_identifier ([[(LTTMeta *) [yyvsp[0].v _elementAtIndex: 0]
						    lttName] internal]);
	    ;
    break;}
case 134:
#line 1756 "parse.y"
{
	      yyval.v = [CO_OTMTuple tupleWithSequence: yyvsp[-1].v];
	    ;
    break;}
case 138:
#line 1769 "parse.y"
{
	      ABORT ();
	    ;
    break;}
case 139:
#line 1776 "parse.y"
{
	      if (current_method)
		{
		  otm_qualifiers q = [current_method qualifiers];

		  /* A method declaration in an implementation is only
                     allowed if it is a redeclaration, deferred or
                     foreign.  */
		  if (![current_method definedp] && !Q_REDO (q)
		      && !Q_DEFERRED (q) && ![current_method foreign])
		    error (@"method definition missing");

		  add_method_def (current_method);
		}
	    ;
    break;}
case 140:
#line 1792 "parse.y"
{
	      if (current_method)
		{
		  id f;

		  if ([current_method deferredp])
		    error (@"definition of method declared deferred");

		  f = [current_method foreign];
		  if (f)
		    error (@"definition of method declared extern", f);

		  current_method = add_method_def (current_method);
		}
	    ;
    break;}
case 142:
#line 1812 "parse.y"
{
	      enter_compound ();
	      if (current_method)
		{
		  OTMType *t = [current_method returnType];

		  if (t != basic_type[BT_VOID])
		    {
		      OTMTuple *rvn = [current_method returnVariables];

		      /* Initialize the return value.  */
		      if (rvn)
			[current_method setReturnValue: rvn];
		      else
			do_return_stmt (0, nil_something_with_type (t));
		    }

		  emit_conditions_pre (current_method);
		}
	    ;
    break;}
case 143:
#line 1833 "parse.y"
{
	      if ([current_method haveReturnStatement])
		emit_statement ([current_method setHaveReturnStatement]);

	      emit_conditions_post (current_method);
	      exit_compound ();
	    ;
    break;}
case 144:
#line 1844 "parse.y"
{
	      enter_compound ();
	    ;
    break;}
case 145:
#line 1848 "parse.y"
{
	      yyval.v = current_compound;
	      exit_compound ();
	    ;
    break;}
case 146:
#line 1856 "parse.y"
{
		  emit_expr (void_expr);
		;
    break;}
case 150:
#line 1869 "parse.y"
{
	      if (current_compound && yyvsp[0].v)
		{
		  [current_compound setValue: yyvsp[0].v];
		  [current_compound releaseTemporaryVariables];
		}
	    ;
    break;}
case 152:
#line 1899 "parse.y"
{
	      yyval.v = emit_expr (yyvsp[0].v);
	    ;
    break;}
case 153:
#line 1903 "parse.y"
{
	      yyval.v = emit_expr (yyvsp[0].v);
	    ;
    break;}
case 154:
#line 1909 "parse.y"
{
	      enter_compound ();
	    ;
    break;}
case 155:
#line 1913 "parse.y"
{
	      yyval.v = current_compound;
	      exit_compound ();
	    ;
    break;}
case 157:
#line 1919 "parse.y"
{
	      if (!flag_inhibit_empty)
		warning (@"empty expression");
	      yyval.v = void_expr;
	    ;
    break;}
case 158:
#line 1928 "parse.y"
{
	      enclosing_type = yyvsp[0].v;
	    ;
    break;}
case 159:
#line 1932 "parse.y"
{
	      yyval.v = yyvsp[0].v;
	    ;
    break;}
case 161:
#line 1940 "parse.y"
{
	      yyval.v = yyvsp[0].v;
	    ;
    break;}
case 162:
#line 1947 "parse.y"
{
	      yyval.v = create_local_var (yyvsp[0].v, enclosing_type, nil);
	    ;
    break;}
case 163:
#line 1951 "parse.y"
{
	      yyval.v = create_local_var (yyvsp[-2].v, enclosing_type, yyvsp[0].v);
	    ;
    break;}
case 164:
#line 1958 "parse.y"
{
	      yyval.v = [CO_OTMCondExpr new];
	    ;
    break;}
case 165:
#line 1962 "parse.y"
{
	      [yyvsp[-1].v setIf: yyvsp[0].v];
	    ;
    break;}
case 166:
#line 1966 "parse.y"
{
	      [yyvsp[-3].v setThen: yyvsp[0].v];
	    ;
    break;}
case 167:
#line 1970 "parse.y"
{
	      yyval.v = yyvsp[-5].v;
	      [yyval.v setElse: yyvsp[0].v];
	    ;
    break;}
case 168:
#line 1978 "parse.y"
{
	      yyval.v = nil;
	    ;
    break;}
case 169:
#line 1982 "parse.y"
{
	      yyval.v = yyvsp[0].v;
	    ;
    break;}
case 170:
#line 1989 "parse.y"
{
	      current_compound = [CO_OTMLoop
				   loopWithContainer: current_compound];
	    ;
    break;}
case 171:
#line 1994 "parse.y"
{
	      [(OTMLoop *) current_compound startLoopEnd];
	      [(OTMLoop *) current_compound setCondition: yyvsp[-1].v atEnd: 1];

	      yyval.v = current_compound;
	      current_compound = [current_compound container];
	    ;
    break;}
case 172:
#line 2005 "parse.y"
{
	      current_compound = [CO_OTMLoop
				   loopWithContainer: current_compound];
	    ;
    break;}
case 173:
#line 2010 "parse.y"
{
	      [(OTMLoop *) current_compound setCondition: yyvsp[0].v atEnd: 0];
	    ;
    break;}
case 174:
#line 2014 "parse.y"
{
	      yyval.v = current_compound;
	      [(OTMLoop *) current_compound startLoopEnd];
	      current_compound = [current_compound container];
	    ;
    break;}
case 175:
#line 2023 "parse.y"
{
	      enter_compound ();
	      emit_statement (yyvsp[-1].v);
	      current_compound
		= [CO_OTMLoop loopWithContainer: current_compound];
	    ;
    break;}
case 176:
#line 2030 "parse.y"
{
	      [(OTMLoop *) current_compound setCondition: yyvsp[-1].v atEnd: 0];
	    ;
    break;}
case 177:
#line 2034 "parse.y"
{
	      OTMCompound *loop = current_compound;

	      [current_compound startLoopEnd];
	      emit_statement (yyvsp[-2].v);
	      current_compound = [current_compound container];
	      [current_compound setValue: emit_expr (loop)];
	      yyval.v = current_compound;
	      exit_compound ();
	    ;
    break;}
case 178:
#line 2055 "parse.y"
{
	      yyval.v = do_return_stmt (yyvsp[-1].i, yyvsp[0].v);
	    ;
    break;}
case 179:
#line 2059 "parse.y"
{
	      yyval.v = do_return_stmt (yyvsp[0].i, void_expr);
	    ;
    break;}
case 180:
#line 2065 "parse.y"
{ yyval.i = 0; ;
    break;}
case 181:
#line 2066 "parse.y"
{ yyval.i = 1; ;
    break;}
case 182:
#line 2071 "parse.y"
{
	      yyval.v = [CO_OTMAssignment assignmentWithLhs: yyvsp[-2].v rhs: yyvsp[0].v];
	    ;
    break;}
case 183:
#line 2075 "parse.y"
{
	      yyval.v = [CO_OTMModAssign assignmentWithLhs: yyvsp[0].v
				 rhs: (id) tll_small_int[1]
				 operator: BO_ADD postp: NO];
	    ;
    break;}
case 184:
#line 2081 "parse.y"
{
	      yyval.v = [CO_OTMModAssign assignmentWithLhs: yyvsp[-1].v
				 rhs: (id) tll_small_int[1]
				 operator: BO_ADD postp: YES];
	    ;
    break;}
case 185:
#line 2087 "parse.y"
{
	      yyval.v = [CO_OTMModAssign assignmentWithLhs: yyvsp[0].v
				 rhs: (id) tll_small_int[1]
				 operator: BO_SUB postp: NO];
	    ;
    break;}
case 186:
#line 2093 "parse.y"
{
	      yyval.v = [CO_OTMModAssign assignmentWithLhs: yyvsp[-1].v
				 rhs: (id) tll_small_int[1]
				 operator: BO_SUB postp: YES];
	    ;
    break;}
case 187:
#line 2099 "parse.y"
{
	      yyval.v = [CO_OTMModAssign assignmentWithLhs: yyvsp[-2].v rhs: yyvsp[0].v operator: yyvsp[-1].i
				 postp: YES];
	    ;
    break;}
case 188:
#line 2104 "parse.y"
{
	      yyval.v = build_invocation ([yyvsp[-2].v car],
				     CONS (CONS (MNP_SET_AT_1, yyvsp[0].v),
					   CONS (CONS (MNP_SET_AT_2, [yyvsp[-2].v cdr]),
						 nil)), 0, nil);
	    ;
    break;}
case 189:
#line 2115 "parse.y"
{
	      if ([[yyvsp[-1].v elements] length] == 1)
		yyvsp[-1].v = [[yyvsp[-1].v elements] _elementAtIndex: 0];
	      yyval.v = CONS (yyvsp[-3].v, yyvsp[-1].v);
	    ;
    break;}
case 190:
#line 2121 "parse.y"
{
	      error (@"error in index expression");
	      yyval.v = [CO_OTMError sharedError];
	    ;
    break;}
case 191:
#line 2129 "parse.y"
{
	      yyval.v = nil;
	    ;
    break;}
case 193:
#line 2137 "parse.y"
{
	      yyval.v = nil;
	    ;
    break;}
case 194:
#line 2141 "parse.y"
{
	      enter_compound ();
	    ;
    break;}
case 195:
#line 2145 "parse.y"
{
	      yyvsp[0].v = emit_expr (yyvsp[0].v);
	      if (yyvsp[0].v)
		[current_compound setValue: yyvsp[0].v];
	      yyval.v = current_compound;
	      exit_compound ();
	    ;
    break;}
case 209:
#line 2178 "parse.y"
{
	      if (yyvsp[0].v && yyvsp[0].v != an_error)
		{
		  if ([yyvsp[0].v cdr])
		    error (@"too many elements in catch tag");

		  yyvsp[0].v = [resolve_expr ([yyvsp[0].v car], CONS (the_any_ref_type, nil),
				      NULL, [current_either semantics])
			elaborate];
		}
	      current_compound = [CO_OTMCatch catchWithTag: yyvsp[0].v
					   container: current_compound];
	    ;
    break;}
case 210:
#line 2192 "parse.y"
{
	      [current_compound setValue: emit_expr (yyvsp[0].v)];
	      yyval.v = current_compound;
	      current_compound = [current_compound container];
	    ;
    break;}
case 211:
#line 2198 "parse.y"
{
	      enter_compound ();

	      /* This is naughty: a local variable for tom code to
                 reference the argument (with the same name) to the
                 function containing the handlers.  */
	      emit_local_var ([CO_OTMArgument variableWithName: @"condition"
					   type: tom_condition_instance]);

	      if (![tom_condition_instance declaredp]
		  && ![tom_condition_instance definedp])
		load_interface ((LTTInstance *)
				[tom_condition_instance structure]);
	    ;
    break;}
case 212:
#line 2213 "parse.y"
{
	      current_compound = [CO_OTMBind bindWithContainer:
					     current_compound];
	      [(OTMBind *) current_compound setHandlers: yyvsp[0].v];
	    ;
    break;}
case 213:
#line 2219 "parse.y"
{
	      [current_compound setValue: emit_expr (yyvsp[0].v)];
	      yyval.v = current_compound;
	      current_compound = [current_compound container];
	      [current_compound setValue: emit_expr (yyval.v)];
	      yyval.v = current_compound;
	      current_compound = [current_compound container];
	    ;
    break;}
case 214:
#line 2228 "parse.y"
{
	      if (yyvsp[-1].v && yyvsp[-1].v != an_error)
		{
		  if ([yyvsp[-1].v cdr])
		    error (@"too many elements in unwind protection");

		  enter_compound ();
		  [current_compound setValue: emit_expr ([yyvsp[-1].v car])];
		  yyvsp[-1].v = current_compound;
		  current_compound = [current_compound container];
		}

	      current_compound = [CO_OTMUnwind unwindWithProtection: yyvsp[-1].v
					    container: current_compound];
	      [current_compound setValue: emit_expr (yyvsp[0].v)];
	      yyval.v = current_compound;
	      current_compound = [current_compound container];
	    ;
    break;}
case 215:
#line 2250 "parse.y"
{
	      yyval.v = yyvsp[-1].v;
	    ;
    break;}
case 216:
#line 2257 "parse.y"
{
	      yyval.v = CONS (yyvsp[0].v, nil);
	    ;
    break;}
case 217:
#line 2261 "parse.y"
{
	      yyval.v = [yyvsp[-2].v nconc: CONS (yyvsp[0].v, nil)];
	    ;
    break;}
case 218:
#line 2268 "parse.y"
{
	      yyval.v = [CO_OTMBreak jumpStatement];
	    ;
    break;}
case 219:
#line 2272 "parse.y"
{
	      yyval.v = [CO_OTMBreak jumpStatementWithValue: yyvsp[0].v];
	    ;
    break;}
case 220:
#line 2279 "parse.y"
{
	      yyval.v = [CO_OTMContinue jumpStatement];
	    ;
    break;}
case 221:
#line 2283 "parse.y"
{
	      yyval.v = [CO_OTMContinue jumpStatementWithValue: yyvsp[0].v];
	    ;
    break;}
case 223:
#line 2291 "parse.y"
{
	      if (!yyvsp[0].v || yyvsp[0].v == an_error)
		yyval.v = [CO_OTMError sharedError];
	      else
		yyval.v = invocation ([yyvsp[0].v car], unique_identifier (MNP_AT_1),
				 [yyvsp[0].v cdr]);
	    ;
    break;}
case 224:
#line 2299 "parse.y"
{
	      yyval.v = op_invocation1 (builtin_operator_name[BO_NEG], yyvsp[0].v);
	    ;
    break;}
case 225:
#line 2303 "parse.y"
{
	      yyval.v = op_invocation1 (builtin_operator_name[BO_INV], yyvsp[0].v);
	    ;
    break;}
case 226:
#line 2307 "parse.y"
{
	      yyval.v = op_invocation1 (builtin_operator_name[BO_NOT], yyvsp[0].v);
	    ;
    break;}
case 227:
#line 2311 "parse.y"
{
	      yyval.v = [CO_OTMOld with: yyvsp[0].v];
	    ;
    break;}
case 228:
#line 2315 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_MUL], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 229:
#line 2319 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_DIV], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 230:
#line 2323 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_MOD], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 231:
#line 2327 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_ADD], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 232:
#line 2331 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_SUB], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 233:
#line 2335 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_SHL], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 234:
#line 2339 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_SHR], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 235:
#line 2343 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_LSR], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 236:
#line 2347 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_AND], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 237:
#line 2351 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_OR], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 238:
#line 2355 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_EOR], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 239:
#line 2359 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_LT], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 240:
#line 2363 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_LE], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 241:
#line 2367 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_EQ], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 242:
#line 2371 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_NE], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 243:
#line 2375 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_GE], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 244:
#line 2379 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_GT], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 245:
#line 2383 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_SC_AND], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 246:
#line 2387 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_SC_OR], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 247:
#line 2391 "parse.y"
{
	      yyval.v = op_invocation2 (builtin_operator_name[BO_IMPLIES], yyvsp[-2].v, yyvsp[0].v);
	    ;
    break;}
case 248:
#line 2395 "parse.y"
{
	      yyval.v = [CO_OTMCondExpr iteWithCondition: yyvsp[-4].v thenPart: yyvsp[-2].v elsePart: yyvsp[0].v];
	    ;
    break;}
case 249:
#line 2399 "parse.y"
{
	      error (@"`:' expected");
	      yyval.v = [CO_OTMError sharedError];
	    ;
    break;}
case 252:
#line 2408 "parse.y"
{
	      yyval.v = nil;

	      /* Look for the variable in the current compound.  If the
                 compound is not set, we could be in a method condition,
                 and search for a method argument.  */
	      if (current_compound)
		yyval.v = [current_compound searchVariableNamed: yyvsp[0].v];
	      else if (current_method)
		yyval.v = [current_method searchVariableNamed: yyvsp[0].v];

	      if (yyval.v)
		yyval.v = [OTMVarRef referenceToVariable: yyval.v];
	      else
		{
		  yyval.v = [C_EITHER_SEMANTICS searchEntityNamed: yyvsp[0].v
			supers: YES class: YES variables: YES constants: YES];

		  if (!yyval.v)
		    if (!of)
		      yyval.v = [[CO_OTMIdentifier gcAlloc] initWithName: yyvsp[0].v];
		    else
		      {
			error (@"undeclared variable `%@'", yyvsp[0].v);
			if (current_compound)
			  {
			    yyval.v = [CO_OTMLocalVar variableWithName: yyvsp[0].v
					    type: [ltt_instance_any semantics]];
			    cerror (@"inventing `%@ %@'",
				    type_name ([yyval.v type]), yyvsp[0].v);
			    emit_local_var (yyval.v);
			  }
		      }
		}
	    ;
    break;}
case 253:
#line 2444 "parse.y"
{
	      yyval.v = void_expr;
	    ;
    break;}
case 254:
#line 2448 "parse.y"
{
	      yyval.v = nil_expr;
	    ;
    break;}
case 259:
#line 2469 "parse.y"
{
	      if (yyvsp[-3].v && yyvsp[-1].v)
		{
		  if (yyvsp[-3].v == basic_type[BT_SELECTOR]
		      && [yyvsp[-1].v isKindOf: [CO_OTMStringCST self]])
		    yyval.v = [[CO_LTTSelector selectorWithMangledName:
					    [[(OTMStringCST *) yyvsp[-1].v structure]
					      string]] semantics];
		  else
		    yyval.v = [CO_OTMCast castWithExpr: yyvsp[-1].v type: yyvsp[-3].v];
		}
	      else
		yyval.v = yyvsp[-1].v;
	    ;
    break;}
case 260:
#line 2484 "parse.y"
{
	      error (@"cast of super not allowed");
	      yyval.v = [CO_OTMError sharedError];
	    ;
    break;}
case 261:
#line 2489 "parse.y"
{
	      error (@"parse error at `%s'", yytext);
	      yyval.v = [CO_OTMError sharedError];
	    ;
    break;}
case 264:
#line 2502 "parse.y"
{
	      yyval.v = build_invocation (yyvsp[-2].v, yyvsp[-1].v, 0, nil);
	    ;
    break;}
case 265:
#line 2506 "parse.y"
{
	      yyval.v = build_invocation ([[(OTMMeta *) [(LTTMeta *) yyvsp[-2].v semantics]
				       itsClass] metaReference], yyvsp[-1].v, 0, nil);
	    ;
    break;}
case 266:
#line 2511 "parse.y"
{
	      yyval.v = build_invocation
		([current_method argumentNamed: TO_NAME_SELF], yyvsp[-1].v, 1, nil);
	    ;
    break;}
case 267:
#line 2517 "parse.y"
{
	      yyval.v = build_invocation
		([current_method argumentNamed: TO_NAME_SELF], yyvsp[-1].v, 1, yyvsp[-3].v);
	    ;
    break;}
case 268:
#line 2522 "parse.y"
{
	      OTMExpr *e = [CO_OTMMetaRef metaRefWithMeta:
				       [[current_either itsClass] semantics]];
	      yyval.v = invocation (e, yyvsp[-1].v, yyvsp[0].v);
	    ;
    break;}
case 269:
#line 2528 "parse.y"
{
	      error (@"error in invocation");
	      yyval.v = [CO_OTMError sharedError];
	    ;
    break;}
case 273:
#line 2542 "parse.y"
{
	      yyval.v = [yyvsp[-1].v nconc: yyvsp[0].v];
	    ;
    break;}
case 274:
#line 2549 "parse.y"
{
	      yyval.v = CONS (CONS (yyvsp[-1].v, yyvsp[0].v), nil);
	    ;
    break;}
case 275:
#line 2556 "parse.y"
{
	      if ([[yyvsp[-1].v elements] length] == 1)
		yyval.v = [[yyvsp[-1].v elements] _elementAtIndex: 0];
	      else
		{
		  yyval.v = yyvsp[-1].v;
		}
	    ;
    break;}
case 276:
#line 2565 "parse.y"
{
	      error (@"error in tuple");
	      yyval.v = [CO_OTMError sharedError];
	    ;
    break;}
case 277:
#line 2573 "parse.y"
{
		yyval.v = [CO_OTMTuple tuple];
		[yyval.v addElement: yyvsp[0].v];
	    ;
    break;}
case 278:
#line 2578 "parse.y"
{
		yyval.v = [CO_OTMTuple tuple];
		[yyval.v addElement: nil];
	    ;
    break;}
case 279:
#line 2583 "parse.y"
{
		[yyvsp[-2].v addElement: yyvsp[0].v];
		yyval.v = yyvsp[-2].v;
	    ;
    break;}
case 280:
#line 2588 "parse.y"
{
		[yyvsp[-1].v addElement: nil];
		yyval.v = yyvsp[-1].v;
	    ;
    break;}
case 281:
#line 2596 "parse.y"
{
	      yyval.v = CONS (yyvsp[0].v, nil);
	    ;
    break;}
case 282:
#line 2600 "parse.y"
{
	      yyval.v = [yyvsp[-2].v nconc: CONS (yyvsp[0].v, nil)];
	    ;
    break;}
case 284:
#line 2608 "parse.y"
{
	      error (@"`;' expected");
	    ;
    break;}
case 286:
#line 2616 "parse.y"
{
	      error (@"`)' expected");
	    ;
    break;}
case 288:
#line 2624 "parse.y"
{
	      error (@"`]' expected");
	    ;
    break;}
case 290:
#line 2635 "parse.y"
{
	      OTMMeta *oins = [yyvsp[0].v semantics];

	      yyval.v = yyvsp[0].v;
	      if (yyvsp[0].v && ![oins fullyLoaded])
		load_interface (yyvsp[0].v);
	    ;
    break;}
case 291:
#line 2646 "parse.y"
{
	      yyval.v = instance_in_unit (nil, current_unit, yyvsp[0].v);
	    ;
    break;}
case 292:
#line 2650 "parse.y"
{
	      yyval.v = instance_in_unit ([[(LTTMeta *) [yyvsp[-2].v _elementAtIndex: 0]
					   lttName] internal],
				     current_unit, yyvsp[0].v);
	    ;
    break;}
case 293:
#line 2656 "parse.y"
{
	      yyval.v = instance_in_unit (yyvsp[-2].v, current_unit, yyvsp[0].v);
	    ;
    break;}
case 295:
#line 2664 "parse.y"
{
	      error (@"inventing class `%@'", yyvsp[0].v);

	      yyval.v = [ltt_missing_unit metaWithName: yyvsp[0].v];	      
	    ;
    break;}
case 296:
#line 2670 "parse.y"
{
	      LTTUnit *u = [CO_LTTUnit unitNamed: yyvsp[-2].v];

	      error (@"inventing class `%@.%@'", yyvsp[-2].v, yyvsp[0].v);

	      if (!u)
		{
		  error (@"unknown unit `%@'", yyvsp[-2].v);
		  u = ltt_missing_unit;
		}

	      yyval.v = [u metaWithName: yyvsp[0].v];
	    ;
    break;}
case 298:
#line 2688 "parse.y"
{
	      yyval.v = [[(LTTMeta *) [yyvsp[0].v _elementAtIndex: 0] lttName] internal];
	    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/share/misc/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 2692 "parse.y"

